$!helo!
$!------------------------------------------------------------------------
$!
$!	Filename:	resckit.com
$!	Author:		Maulis, Adam
$!	Cre.Date:	19-AUG-1999
$!	Version:	0.1
$!
$! Abscrtact:
$!
$!	Create bootable mimimum VMS system, for 
$!      rescue reasons.
$!
$!
$! Copyright: GPL version 2 or newer.
$!
$!
$!-----------------------------------------------------------------------
$!
$! Parameters:
$!      P1 target device (mounted)
$!      P2 target topsys in hex number (0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F)
$!           ( system will be created on 'p1'[sys'p2']
$!	p3 one of (log, debug )
$!
$!----------------------------------
$!	'F$VERIFY(0)
$	SET := SET
$	SET :== SET
$	SET SYMBOL/SCOPE=(NOLOCAL,NOGLOBAL)
$	SAY := WRITE SYS$OUTPUT
$	!
$	! Error handling
$	!
$	SET CONTROL=(Y,T)
$	ON CONTROL_Y THEN goto errlabel_ctrly
$	ON WARNING THEN goto errlabel_general
$	!
$	! Arch checking
$	!
$	if f$getsyi("ARCH_TYPE") .ne. 1
$	then
$	   say "%RESCKIT-F-NOALPHA, resckit not supported on alpha"
$	   exit
$	endif
$	!
$	! sure? :-)
$	!
$	read sys$command /prompt="Are you satisfied with the backup of your system? " answ
$       if .not. answ then exit
$	!
$	! Privilege checking
$	!
$	saved_uic=f$user()
$	prv_bypass = f$setprv("NOBYPASS")
$	if prv_bypass .eqs. "BYPASS" then -
		say "%RESCKIT-I-NOBYPASS, disabling bypass privilege"
$	prv_share = f$setprv("NOSHARE")
$	if prv_share .eqs. "SHARE" then -
		say "%RESCKIT-I-NOSHARE, disabling share privilege"
$	prv_need="log_io"  !writeboot
$	! chk system uic:
$	if saved_uic .nes. f$fao("!%I",%o200004) then prv_need=prv_need+",CMKRNL"
$	prv_saved=f$setprv(prv_need)
$	if .not. f$privilege(prv_need)
$	then
$	   say "%RESCKIT-F-NOTALLPRIV, not all requested privileges authorized"
$	   exit 
$	endif
$	if saved_uic .nes. f$fao("!%I",%o200004) then  set uic [1,4]
$	tmp = f$setprv(prv_saved) ! not need -- yet.
$	!
$	! Parameter processing
$	!
$ label_p1:
$	if p1 .eqs. ""
$	then
$	   read/end_of=cleanup sys$command p1 /prompt="   Target device [?]: "
$	endif
$	p1 = f$edit(p1,"TRIM,UPCASE")
$	if p1 .eqs. "" .or. p1 .eqs. "?"
$	then
$	   type sys$input

	Name of device where the rescue kit will be created.
	For example: dua0:, sys$sysdevice

$	   p1 = ""
$	   goto label_p1
$	endif
$	if .not. f$getdvi(p1,"EXISTS")
$	then
$	   say "%RESCKIT-F-NOSUCHDEV, device ''p1' does not exist"
$	   exit
$	endif
$	if .not. f$getdvi(p1,"MNT") .or. f$getdvi(p1,"FOR")
$	then
$	   say "%RESCKIT-F-DNR, device ",f$getdvi(p1,"DEVNAM")," not mounted, or foreign mounted"
$	   exit
$	endif
$	if  f$getdvi(p1,"ALL") .and. ( f$getdvi(p1,"PID") .nes. f$getjpi("","PID") )
$	then
$	   say "%RESCKIT-F-DEVALLOC, device already allocated by another user"
$	   exit
$	endif
$	if  f$getdvi(p1,"FREEBLOCKS") .lt. 21000
$	then
$	   say "%RESCKIT-F-NOSPACE, insufficient disk space to create rescue kit"
$	   say "%RESCKIT-F-NEED at least 21000 blocks needed"
$	   exit
$	endif
$	define/process resckit_target 'f$getdvi(p1,"DEVNAM")
$	!
$	! p2 processing
$	!
$	valid_topsys="/0/1/2/3/4/5/6/7/8/9/A/B/C/D/E/F/"
$ label_p2:
$	if p2 .eqs. ""
$	then
$	   read/end_of=cleanup sys$command p2 /prompt="   topsys specification [?]: "
$	endif
$	p2 = f$edit(p2,"TRIM,UPCASE")
$	if p2 .eqs. "" .or. p2 .eqs. "?"
$	then
$	   type sys$input

	Specification of the top system directory where the rescue kit
	will be created. You must specify only one hexadecimal 
	digit: 0 for [SYS0.],  E for [SYSE.], etc.

$	   p2 = ""
$	   goto label_p2
$	endif
$	p2 = f$edit(p2,"UPCASE,TRIM")
$	if f$length(p2) .ne. 1 
$	then
$	   say "%RESCKIT-F-INVTOPSYS, invalid topsys specification"
$	   say "-RESCKIT-W-NOTHEX, ''p2' is not a hexadecimal number"
$	   goto cleanup
$	endif
$	if f$locate("/"+p2+"/",valid_topsys) .eq. f$length(valid_topsys)
$	then
$	   say "%RESCKIT-F-INVTOPSYS, invalid topsys specification"
$	   say "-RESCKIT-W-NOTHEX, ''p2' is not a hexadecimal number"
$	   goto cleanup
$	endif
$	define /process resckit_topsys resckit_target:[sys'p2'.] /trans=conc
$	!
$	!
$	! p3 processing
$	!
$	!
$	resckit_log = ""
$	if p3 .eqs. "LOG" then resckit_log = "/LOG"
$	if p3 .eqs. "DEBUG" 
$	then
$	   resckit_log = "/LOG"
$	   set ver
$	endif
$	!
$	! dir check
$	!
$	if f$search("resckit_target:[000000]sys''p2'.dir") .nes. ""
$	then
$	   say "%RESCKIT-F-INVTOPSYS, invalid topsys specification"
$	   say "-RMS-E-FEX, file already exists, not superseded"
$	   goto cleanup
$	endif
$	resckit_otheros = "false"
$	if f$search("resckit_target:[000000]sysexe.dir") .nes. "" .or. -
	   f$search("resckit_target:[000000]sys%.dir") .nes. ""
$	then
$	   say ""
$	   say "	There is a system in target disk ",f$getdvi(p1,"DEVNAM")
$	   say "	Operating system versions must equal"
$	   say ""
$	   read sys$command /prompt="		Do you want to continue anyway? [N] " answ
$          if .not. answ then goto cleanup
$	   resckit_otheros = "true"
$	endif
$	!
$	!
$	! Build system directories
$	!
$	!
$	say "%RESCKIT-I-BLDSYS, building system directories"
$	cdpol = "create /dir /prot=(s:rwe,o:rwe,g:re,w:re) /owner=[1,4] "+resckit_log
$	cdpol resckit_target:[sys'p2'] 
$	cdpol resckit_topsys:[sys$ldr] 
$	cdpol resckit_topsys:[sysexe] 
$	cdpol resckit_topsys:[sysmsg] 
$	cdpol resckit_topsys:[syslib] 
$	!
$	!
$	! Copy VMS executive + main drivers
$	!
$	!
$	say "%RESCKIT-I-CPBASE, copying VMS base executive + main drivers"
$	open /read stadat SYS$UPDATE:STABACKIT-TABLE.DAT
$	read stadat _tmp 					! read the copyright line
$ label_stadat_read:
$	read stadat /end_of_label=label_end_stadat_read line
$	line = f$edit(line,"UNCOMMENT,TRIM,COMPRESS")
$	if line .eqs. "" then goto label_stadat_read
$	filename = f$element(0," ",line)
$	target_dir = "sys$ldr"
$	if f$locate("SYSEXE",line) .ne. f$length(line) then target_dir = "sysexe"
$	if f$search("resckit_topsys:[''target_dir']''filename'") .nes. "" then goto label_stadat_read
$	if f$search("sys$sysroot:[''target_dir']''filename'") .eqs. "" then goto label_stadat_read
$	if f$locate("CBT",line) .ne. f$length(line)
$	then
$	   call cpl	'target_dir'	'filename'
$	else
$	   call cplc	'target_dir'	'filename'
$	endif
$	goto label_stadat_read
$ label_end_stadat_read:
$	close stadat
$	!
$	!
$	! Create system parameters
$	!
$	!
$	say "%RESCKIT-I-CRESYSPAR, creating system parameter file"
$	define /user resckit_parameter_file resckit_topsys:[sysexe]vaxvmssys.par
$	mc sysgen
		USE DEFAULT
		SET BUGREBOOT           0
		SET DUMPBUG             1
		SET LOCKIDTBL           1792
		SET PHYSICALPAGES       65536		! no pfn fixups please. (ini$pfn_fixup)
		SET POOLPAGING          0
		SET SA_APP              0               ! we have to load unneeded  files
		SET SCSNODE             "RESKIT"
		SET SCSSYSTEMID         65535
		SET SETTIME             1
		SET VAXCLUSTER          0
		SET VBN_CACHE_S         0
		SET VBSS_ENABLE         0
                SET MULTIPROCESSING     0
                SET LOAD_SYS_IMAGES     0
                SET VECTOR_PROC         0
		SET PQL_MWSQUOTA	1024	! FOR BACKUP....
		SET PQL_MWSEXTENT	1024
		SET PQL_MPGFLQUOTA	1024
		SET PQL_MFILLM		100
		SET PQL_MDIOLM		400
		SET PQL_MASTLM		627	!DIOLM+BYTLM+ENQLM+...
		SET PQL_MBIOLM		100
		SET PQL_MBYTLM		30000
		SET PQL_MENQLM		102
                WRITE RESCKIT_PARAMETER_FILE
$	say "%RESCKIT-S-CRDSYSPAR, ",f$getdvi(p1,"DEVNAM"),"[sys''p2'.sysexe]vaxvmssys.par created"
$	!
$	!
$	! copy other part of executive (not needed, if sa_app)
$	!
$	!
$	say "%RESCKIT-I-CPMISC, copying other part of executive"
$	!    boot:
$	call cplc 	sysexe	sysboot_xdelta.exe	! nice program :-)
$	call cplc 	sysexe	opccrash.exe		! nice program too.
$	!    exe$init:
$	call cplc	sys$ldr	lmf$group_table.exe
$	call cplc	sys$ldr	sys$ipc_services.exe
$	call cplc	sys$ldr	sys$transaction_services.exe
$	call cplc	sys$ldr	sys$utc_services.exe
$	call cpl	sysexe	sys$timezone.dat	notneed	!v7.2
$	call cplc	sys$ldr	sys$network_services.exe
$	call cplc	sys$ldr	sys$nta.exe		notneed !v7.2
$	call cplc	sys$ldr	f11bxqp.exe		notneed	!v7.2
$	call cplc	sys$ldr	vaxcluster_cache.exe
$	!call cplc 	sys$ldr	pseudoloa.exe
$	!call cplc 	sys$ldr	vector_processing.exe
$	!call cplc 	sys$ldr	vbss.exe
$	!    sysinit:
$	call cplc	sysexe	f11bxqp.exe		notneed	!v6.2
$	call cplc	sys$ldr	rms.exe
$	call cplc	sys$ldr	ddif$rms_extension.exe
$	call cplc	sys$ldr	recovery_unit_services.exe
$	call cplc	sys$ldr	sysldr_dyn.exe
$	call cplc	sysmsg	sysmsg.exe
$	!    startup:
$	call cpl	sysexe	configure.exe
$	!
$	!
$	! copy all drives
$	!
$	!
$	say "%RESCKIT-I-CPRDVS, copying misc drivers"
$ label_cp_drv2:
$	drv = f$search("sys$common:[sys$ldr]%%driver.exe")
$	if drv .eqs. "" then goto label_end_cp_drv2
$	drv = f$parse(drv,,,"NAME") + ".EXE"
$	call cpl	sys$ldr	'drv'
$	goto label_cp_drv2
$ label_end_cp_drv2:
$ label_cp_drv3:
$	drv = f$search("sys$common:[sys$ldr]%%%driver.exe")
$	if drv .eqs. "" then goto label_end_cp_drv4
$	drv = f$parse(drv,,,"NAME") + ".EXE"
$	call cpl	sys$ldr	'drv'
$	goto label_cp_drv3
$ label_end_cp_drv3:
$ label_cp_drv4:
$	drv = f$search("sys$common:[sys$ldr]%%%%driver.exe")
$	if drv .eqs. "" then goto label_end_cp_drv4
$	drv = f$parse(drv,,,"NAME") + ".EXE"
$	call cpl	sys$ldr	'drv'
$	goto label_cp_drv4
$ label_end_cp_drv4:
$	!
$	!
$	! Create & copy ramdisk support
$	!
$	!
$	say "%RESCKIT-I-CRSETSIZE, creating setsize.exe"
$	open /read /share stacom sys$update:stabackit.com
$	open /write outf sys$scratch:make_setsize_'f$getjpi("","PID")'.com
$	write outf "$!helo!
$	write outf "$! create setsize.exe: setting size of rda0 device"
$	write outf "$!"
$	write outf "$ MACRO /OBJECT=sys$scratch:SETSIZE.OBJ /NOLIST SYS$INPUT"
$ label_ramdisk_read:
$ 	read /end_of=label_end_ramdisk_read stacom line
$	if f$locate("MACRO",line) .ne. f$length(line)
$	then if f$locate("SETSIZE",line) .ne. f$length(line)
$	then 
$	   goto label_ramdisk_setsize_read
$	endif
$	endif
$	goto label_ramdisk_read
$ label_ramdisk_setsize_read:
$ 	read /end_of=label_end_ramdisk_setsize_read stacom line
$	if f$edit(line,"UPCASE,COLLAPSE") .eqs. "$EOD" then goto label_end_ramdisk_setsize_read
$	write outf line
$	goto label_ramdisk_setsize_read
$ label_end_ramdisk_setsize_read:
$ label_end_ramdisk_read:
$	write outf "$ EOD"
$	write outf "$ LINK SYS$SCRATCH:SETSIZE /EXE=RESCKIT_TOPSYS:[SYSEXE]SETSIZE.EXE"
$	write outf "$ DELETE /NOLOG SYS$SCRATCH:SETSIZE.OBJ;
$	close stacom
$	close outf
$	@ sys$scratch:make_setsize_'f$getjpi("","PID")'.com
$	delete /nolog sys$scratch:make_setsize_'f$getjpi("","PID")'.com;
$	set sec /prot=(s:rwed,o:rwed,g:re,w:re) /owner=[1,4] resckit_topsys:[sysexe]setsize.exe
$	!
$	!
$	! Copy DCL main support
$	!
$	!
$	say "%RESCKIT-I-DCLTBL, creating reduced DCL tables"
$	gosub credcltbl
$	copy/prot=(s:rwed,o:rwed,g:re,w:re)/log sys$scratch:dcltbl_'f$getjpi("","PID")'.exe resckit_topsys:[syslib]dcltables.exe
$	delete sys$scratch:dcltbl_'f$getjpi("","PID")'.exe;
$	say "%RESCKIT-I-CPDCL, copying DCL support"
$	call cpl	sysexe	loginout.exe
$	call cpl	sysexe	dcl.exe
$	call cpl	sysexe	copy.exe
$	call cpl	sysexe	create.exe
$	call cpl	sysexe	delete.exe
$	call cpl	sysexe	directory.exe
$	call cpl	sysexe	dump.exe		notneed
$	call cpl	sysexe	rundet.exe		notneed
$	call cpl	sysexe	rename.exe
$	call cpl	sysexe	search.exe		notneed
$	call cpl	sysexe	set.exe
$	call cpl	sysexe	setshosecur.exe		notneed
$	call cpl	sysexe	show.exe
$	call cpl	sysexe	cdu.exe			notneed
$	call cpl	sysexe	setwatch.exe		notneed
$	call cpl	sysexe	hscpad.exe		notneed
$	call cpl	sysexe	type.exe		notneed
$	call cpl	sysexe	writeboot.exe		notneed
$	call cpl	syslib	librtl.exe
$	call cpl	syslib	librtl2.exe
$	call cpl	syslib	secureshr.exe
$	call cpl	syslib	secureshrp.exe
$	call cpl	syslib	util$share.exe
$	call cpl	sysmsg	cliutlmsg.exe
$	call cpl	sysmsg	shrimgmsg.exe
$	call cpl	sysmsg	filmntmsg.exe
$	!
$	!
$	! Copy SYSGEN & INSTALL support
$	!
$	!
$	say "%RESCKIT-I-CPINST, copying SYSGEN & INSTALL support"
$	call cpl	sysexe	sysgen.exe
$	call cpl	sysexe	install.exe
$	call cpl	syslib	lbrshr.exe
$	call cpl	syslib	scrshr.exe
$	call cpl	syslib	smgshr.exe		! :-(
$	!
$	!
$	! Copy BCAKUP, INITIALIZE, MOUNT, DISMOUNT support
$	!
$	!
$	say "%RESCKIT-I-CPBACK, copying BACKUP (init, mount) support"
$	call cpl	sysexe	backup.exe
$	call cpl	sysexe	init.exe
$	call cpl	sysexe	vmount.exe
$	call cpl	sysexe	dismount.exe
$	call cpl	syslib	mmeshr.exe
$	call cpl	syslib	decc$shr.exe
$	call cpl	syslib	cma$tis_shr.exe
$	call cpl	syslib	backupshr.exe		notneed !v7.2
$	call cpl	syslib	encrypshr.exe
$	call cpl	syslib	librtl.exe
$	call cpl	syslib	dismntshr.exe
$	call cpl	syslib	mountshr.exe
$	call cpl	syslib	init$shr.exe
$	!
$	!
$	! Copy AUTHORIZE & login support
$	!
$	!
$	say "%RESCKIT-I-CPAUTH, copying authorize support"
$	call cpl	sysexe	authorize.exe		notneed
$	call cpl	syslib	mthrtl.exe		notneed
$	call cpl	syslib	uvmthrtl.exe		notneed
$	call cpl	syslib	plirtl.exe		notneed
$	!
$	!
$	! Copy EDT support
$	!
$	!
$	say "%RESCKIT-I-CPEDT, copying EDT support"
$	call cpl	sysexe	edt.exe			notneed
$	call cpl	syslib	edtshr.exe		notneed
$	!
$	!
$	! Copy ANALYZE support: analyzobj,sda,verify,erf.exe,analyzbad
$	!
$	!
$	say "%RESCKIT-I-CPANAL, copying ANALYZE/obj/imag/crash/disk/error support"
$	call cpl	sysexe	analyzobj.exe		notneed	! ANAL/IMAGE
$	call cpl	sysexe	sda.exe			notneed	! ANAL/CRASH
$	call cpl	sysexe	sys.stb			notneed
$	call cpl	sysexe	verify.exe		notneed	! ANAL/DISK
$	call cpl	sysexe	erf.exe			notneed	! ANAL/ERROR
$	call cpl	sysexe	erfcntrl.exe		notneed
$	call cpl	sysexe	erfxrp.exe		notneed
$	call cpl	syslib	erfcommon.exe		notneed
$	call cpl	syslib	erfctlshr.exe		notneed
$	call cpl	syslib	erflib.tlb		notneed
$	call cpl	syslib	erfshr.exe		notneed
$	call cpl	syslib	erfshr2.exe		notneed
$	call cpl	syslib	forrtl.exe		notneed
$	call cpl	syslib	dcxshr.exe		notneed
$	call cpl	sysexe	analyzbad.exe		notneed ! ANAL/MEDIA
$	call cpl	sysmsg	sysmgtmsg.exe		notneed
$	call cpl	sysmsg	prgdevmsg.exe		notneed
$	!
$	!
$	!
$	! Create minimum startup.com
$	!
$	!
$	say "%RESCKIT-I-CRESTARTUP, creating rescue startup.com"
$	call crestartup
$	copy 'resckit_log' /prot=(s:rwed,o:rwed,g:re,w:re) -
           sys$startup:vms$initial-050_configure.com -
	   resckit_topsys:[sysexe] 
$	!
$	!
$	!  make bootable
$	!
$	!
$	if .not. resckit_otheros
$	then
$	   set noon
$	   say "%RESCKIT-I-BOOTABLE, making target disk bootable"
$	   cdpol resckit_target:[sysexe]
$	   set file /enter=resckit_target:[sysexe]sysboot.exe resckit_topsys:[sysexe]sysboot.exe 'resckit_log'
$	   tmp = f$setprv("LOG_IO")
$	   run sys$system:writeboot
resckit_topsys:[sysexe]VMB.EXE
1
200
$	endif
$	!
$	!
$	!
$	!
$ done:
$	say "%RESCKIT-I-DONE, rescue kit created on ",f$getdvi(p1,"DEVNAM"),"[SYS''p2'.]  with absolutly no warranty"
$	!
$	!
$	!
$	!
$	!
$ cleanup:
$	on control_y then continue
$	on warning then continue
$	if f$trnlnm("RESCKIT_TARGET","LNM$PROCESS") .nes. "" then deassign resckit_target
$	if f$trnlnm("RESCKIT_TOPSYS","LNM$PROCESS") .nes. "" then deassign resckit_topsys
$	if saved_uic .nes. f$user() 
$	then
$	   tmp=f$setprv("CMKRNL")
$	   set uic 'saved_uic'
$	endif
$	tmp=f$setprv(prv_saved)
$	exit
$	!
$	!
$	!
$ errlabel_ctrly:
$	on control_y then goto cleanup
$	on error then continue
$	say "%RESCKIT-E-ABORT, pressed ctrl-y"
$	goto errlabel_cleanup
$	!
$	!
$ errlabel_general:
$	on error then continue
$	status = $status
$	say "%RESCKIT-F-ERROR, an error has occured: ",status
$	if p3 .eqs. "DEBUG"
$	then
$	   say "%RESCKIT-E-SYMDUMP, dumping symbols: "
$	   show symbol/local *
$	endif
$	goto errlabel_cleanup
$	!
$	!
$ errlabel_cleanup:
$	on control_y then goto cleanup
$	on warning then continue
$	if f$trnlnm("resckit_topsys","LNM$PROCESS") .eqs. "" then goto cleanup !nothing to delete
$	if f$trnlnm("resckit_target","LNM$PROCESS") .eqs. "" then goto cleanup !nothing to delete
$	if f$search("resckit_target:[000000]sys''p2'.dir") .eqs. "" then goto cleanup !nothing to delete
$	say ""
$	say "    If you want to delete all the created files, answer yes."
$	say "    Otherwise, press ctrl-z, ctrl-y, or answer 'no'"
$	say ""
$	read /end=cleanup /error=cleanup /prompt="         Cleanup? [y] " -
		sys$command answ
$	if answ .eqs. "" then answ= "yes"
$	if .not. answ  then goto cleanup
$	!
$	! delete all target files
$	!
$	say "%RESCKIT-I-CLEANUP, cleaning up"
$	if f$trnlnm("STADAT","LNM$PROCESS") .nes. "" then close stadat
$	if f$trnlnm("STACOM","LNM$PROCESS") .nes. "" then close stacom
$	if f$trnlnm("OUTF","LNM$PROCESS")   .nes. "" then close outf
$	dcltblnam = "sys$scratch:dcltbl_"+f$getjpi("","PID")+".*;*"
$	if f$search(dcltblnam) .nes. "" then delete 'dcltblnam
$	mkesetsizenam = "sys$scratch:make_setsize_"++f$getjpi("","PID")+".com;*"
$	if f$search(mkesetsizenam) .nes. "" then delete 'mkesetsizenam
$	define  sys$output nl:
$	define  sys$error nl:
$	set prot=(o:rwed) resckit_topsys:[000000]*.dir;
$	delete resckit_topsys:[*]*.*;*
$	delete resckit_topsys:[000000]*.*;*
$	set prot=(o:rwed) resckit_target:[000000]sys'p2'.dir;
$	delete resckit_target:[000000]sys'p2'.dir;
$	deassign  sys$output
$	deassign  sys$error
$	if f$search("resckit_target:[000000]''p2'.dir") .nes. ""
$	then
$	   say "%RESCKIT-E-CNTDEL, cannot delete ",f$getdvi(p1,"DEVNAM"),"[SYS''p2'...] hierachy."
$	endif
$	goto cleanup
$!
$!
$!
$!
$!
$! How the system boots?
$!
$! bootsector (some systems)
$!       -> VMB  (some systems)
$!           -> SYSBOOT
$!           -> EXEC_INIT.exe
$!           -> swapper process
$!           -> sysinit process
$!           -> startup process (dcl)
$!
$! vms modular executives: 9 000 blocks
$!
$! this kit: 19 000 blocks
$!
$!
$!
$!
$!----------------------------------------------------------------------------
$!
$!  soubroutine section
$!
$!	cpl:		copy /prot= 'resckit_log' 
$!	cplc:		copy /prot= 'resckit_log' /contiguous   and  set file /nomove
$!
$!	crestartup:	create resckit_topsys:[sysexe]startup.com
$!
$!
$!
$!
$!	credcltbl:	create reduced dcltables.exe
$!
$!
$!----------------------------------------------------------------------------
$	!
$	!
$	! cpl:
$	!    copy /prot=(s:rwed,o:rwed,g:re,w:re) 'resckit_log'
$	!	p1: dirspec
$	!	p2: filename
$	!	p3: required (p3 .eqs. "") or not (p3 .eqs. "NOTNEED")
$	!
$ cpl:	subroutine
$	on control_y then exit 44 ! SYSTEM-F-ABORT
$	if p3 .eqs. "NOTNEED" .and. f$search("sys$sysroot:[''p1']''p2'") .eqs. "" then exit
$	if f$search("resckit_topsys:[''p1']''p2'") .nes. "" then exit		! not superseeded
$	copy /prot=(s:rwed,o:rwed,g:re,w:re) 'resckit_log'  sys$sysroot:['p1']'p2' resckit_topsys:['p1']
$	exit '$status
$ endsubroutine
$	!
$	!
$	! cplc:
$	!    copy /prot=(s:rwed,o:rwed,g:re,w:re) 'resckit_log' /contiguous 
$	!    set file /nomove
$	!	p1: dirspec
$	!	p2: filename
$	!	p3: required (p3 .eqs. "") or not (p3 .eqs. "NOTNEED")
$	!
$ cplc:	subroutine
$	on control_y then exit 44 ! SYSTEM-F-ABORT
$	if p3 .eqs. "NOTNEED" .and. f$search("sys$sysroot:[''p1']''p2'") .eqs. "" then exit
$	if f$search("resckit_topsys:[''p1']''p2'") .nes. "" then exit		! not superseeded
$	copy /prot=(s:rwed,o:rwed,g:re,w:re) 'resckit_log' /contiguous  sys$sysroot:['p1']'p2' resckit_topsys:['p1']
$	set file /nomove resckit_topsys:['p1']'p2'
$	exit '$status
$ endsubroutine
$	!
$	!
$	! crestartup:
$	!
$	!
$	!
$	!
$ crestartup:	subroutine
$	on control_y then exit 44 ! SYSTEM-F-ABORT
$	copy /prot=(s:rewd,o:rwed,g:re,w:re) 'resckit_log' -
        sys$input resckit_topsys:[sysexe]startup.com
$ DECK
$!helo!  ------- start of rescue kit startup.com V0.1  'f$verify(0)
$!Author: Maulis, Adam;  maulis@telnet.hu; (c) GPL version 2 or newer
$ set noon
$ write sys$output ""
$ write sys$output "The OpenVMS VAX rescue kit is now executing the system startup procedure."
$ write sys$output ""
$ define /table=lnm$system_directory/super  lnm$dcl_logical lnm$file_dev
$ define/nolog /system/exec sys$common 'f$trnlnm("sys$sysroot") /trans=conceal
$ define/nolog /system/exec sys$sysroot 'f$trnlnm("sys$sysroot") /trans=conceal
$ define /system/exec sys$library sys$sysroot:[syslib]
$ if .not. f$getdvi ("pda0:", "exists") then -
  mc sysgen connect pda0 /noadapter /driver=pddriver
$ if .not. f$getsyi("NOAUTOCONFIG")
$ then
$    define/nolog /sys/exec sys$manager opa0:
$    if f$search("sys$system:vms$initial-050_configure.com") .nes. "" then -
     @sys$system:vms$initial-050_configure.com no
$    wait 0:0:4
$    ctx = ""
$    _tmp = f$context("PROCESS", ctx,"PRCNAM  ","CONFIGURE","EQL")
$    if f$pid(ctx) .nes. "" then stop configure
$    write sys$output  "%STARTUP-I-CONFIG, configuring devices"
$    mc sysgen
     autoconfigure all /log
$    if f$search("sys$system:vms$initial-050_configure.com") .nes. "" then -
     @sys$system:vms$initial-050_configure.com no
$ endif
$ write sys$output  "%STARTUP-I-INSTALL, installing required images"
$ install
add sys$share:secureshrp.exe /prot/open/header/share
add sys$share:mountshr.exe   /prot/open/header/share
add sys$share:dismntshr.exe  /prot/open/header/share/nopurge
add sys$share:mmeshr.exe     /prot/open/header/share
add sys$share:init$shr.exe   /prot/open/header/share
add sys$share:dcltables.exe       /open/header/share
add sys$system:dcl.exe            /open/header/share
add sys$system:loginout.exe       /open/header/share -
    /priv=(CMKRNL,SYSNAM,SYSPRV,LOG_IO,ALTPRI,TMPMBX,AUDIT,SECURITY)
$ if f$getsyi("H_FLOAT_EMULATED") .and. -
 ( f$getsyi("D_FLOAT_EMULATED") .or. .not. f$getsyi("G_FLOAT_EMULATED")) -
 then define/nolog/system/executive_mode mthrtl sys$share:uvmthrtl.exe
$!
$ if .not. f$getdvi ("pda0:","exists")
$ then
$   write sys$output "%STARTUP-E-NORAMDSK, cannot create ramdisk"  
$ else
$   setsize := $setsize
$   setsize 1200		!600 kbytes
$   init/system/header=32 pda0 ramdisk
$   mount/noass/nomessage/system pda0 ramdisk ramdisk
$   create /dir pda0:[sysmgr]
$   create /dir pda0:[sysexe]
$   define /nolog/system/executive sys$manager pda0:[sysmgr]
$   define /nolog/exec/job sys$login pda0:[sysmgr]
$   define /nolog/exec/job sys$scratch pda0:[sysmgr]
$ endif
$  type sys$input
==============================================================================

	Commands:
		open,close,read,write,define,deassign,
		copy,append,directory,delete,create,rename,purge,
		set comm,set sec,set watch,set dev,set vol,set term,
		sh mem, sh sys, sh proc, sh sec, sh dev, sh err,
		anal/obj,anal/imag,anal/disk,anal/crash,anal/error,
		backup,mount,init,dismount,alloc,dealloc,
		edit/edt
	Utilities:
		authorize,writeboot,setsize,sysgen,install

	When you are ready, type 'logout' to shutdown system.

==============================================================================
$ set def sys$login
$ set term/inq/insert/perma opa0:
$ set control=(y,t)
$ spawn /nolog /input=opa0: /prompt="$$$ " 
$ write sys$output "%STARTUP-I-SHUTDOWN, shutting down"
$ install
purge
$ 
$!dismounting disks
$ sysdisk=f$getdvi("SYS$SYSDEVICE","FULLDEVNAM")
$ loop_dismount:
$    dev = f$device(,"DISK")
$    if dev .eqs. "" then goto end_loop_dismount
$    if .not. f$getdvi(dev,"MNT") then goto loop_dismount
$    if f$getdvi(dev,"FULLDEVNAM") .eqs. sysdisk then goto loop_dismount
$    ! what??
$    if (f$getdvi(dev,"DEVCHAR2") .and. %x800000 ).eq. %x800000 then goto loop_dismount
$    dismount/abort/override=checks/nounload 'dev
$ goto loop_dismount
$ end_loop_dismount:
$! final shutdown
$ define opc$unload n
$ define opc$reboot n
$ define opc$nodump y
$ run sys$system:opccrash
$ write sys$output "%RESCKIT-W-NOSHUT, cannot shut down system"
$ write sys$output "%RESCKIT-I-CONSHLT, use console to halt"
$ EOD
$	exit '$status
$ endsubroutine
$	!
$	!
$	! credcltbl:   (called by gosub!! (main error handling))
$	!     create reduced dcltables.exe 
$	!     
$	!   *** this is the last subroutine in this file. ***
$	!
$	!
$ credcltbl: 
$	!
$	! create empty command table
$	!
$	set command sys$input /object=sys$scratch:dcltbl_'f$getjpi("","PID")
		MODULE DCLTABLES
		IDENT "0.0"
$	link/share sys$scratch:dcltbl_'f$getjpi("","PID") -
	        /exe=sys$scratch:dcltbl_'f$getjpi("","PID")
$	!
$	! create command table in two part.
$	!
$	set command /table=sys$scratch:dcltbl_'f$getjpi("","PID") -
        	/out=sys$scratch:dcltbl_'f$getjpi("","PID") -
        	sys$input
$ DECK
MODULE DCLTABLES
IDENT "0.0"


define verb ALLOCATE
   cliroutine ALLOCATE
   prefix CLI$K_ALLO_
   parameter P1, prompt="Device"
      value (required,list,type=$device)
   parameter P2, prompt="Log name"
      value (type=$outlog)
   qualifier GENERIC
   qualifier LOG

define verb ANALYZE
   image ANALYZOBJ
   parameter P1, label=FILE_SPECS, prompt="File(s)"
      value (required,list,type=$infile)
   qualifier CRASH_DUMP, syntax=ANALYZE_CRASH_DUMP, nonnegatable
   qualifier DISK_STRUCTURE, syntax=ANALYZE_DISK_STRUCTURE, nonnegatable
   qualifier ERROR_LOG, syntax=ANALYZE_ERROR_LOG, nonnegatable
   qualifier IMAGE, syntax=ANALYZE_IMAGE, nonnegatable
   qualifier MEDIA, syntax=ANALYZE_MEDIA, nonnegatable
   qualifier OBJECT, nonnegatable, default
!   qualifier SYSTEM, syntax=ANALYZE_SYSTEM, nonnegatable
!      value
   qualifier PROCESS_DUMP, syntax=ANALYZE_PROCESS_DUMP, nonnegatable
   qualifier DBG
      placement=positional
   qualifier EOM
      placement=positional
   qualifier GSD
      placement=positional
   qualifier INCLUDE
      value (list,default="*")
      placement=local
   qualifier INTERACTIVE
   qualifier LNK
      placement=positional
   qualifier MHD
      placement=positional
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$outfile)
   qualifier TBT
      placement=positional
   qualifier TIR
      placement=positional

define syntax ANALYZE_CRASH_DUMP
   image SDA
   parameter P1, label=DUMP_FILE, prompt="Dump File"
      value (required,type=$infile)
   qualifier CRASH_DUMP, default
   qualifier RELEASE
   qualifier SYSTEM
   qualifier SYMBOLS
      value (required,type=$infile)
   disallow (RELEASE and SYSTEM)

define syntax ANALYZE_DISK_STRUCTURE
   image VERIFY
   parameter P1, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier CONFIRM
   qualifier DISK_STRUCTURE, default
   qualifier LIST
      value (type=$outfile)
   qualifier OUTPUT, default
      value (type=$outfile)
   qualifier READ_CHECK
   qualifier REPAIR
   qualifier USAGE
      value (type=$outfile)
   qualifier RECORD_ATTRIBUTES
   qualifier HOMEBLOCKS
   qualifier STATISTICS

define syntax ANALYZE_ERROR_LOG
   image SYS$SYSTEM:ERF.EXE
   parameter P1, label=FILE_SPECS
      value (list,default="SYS$ERRORLOG:ERRLOG.SYS",type=$infile)
   qualifier BEFORE, nonnegatable
      value (type=$datetime)
   qualifier BINARY
      value (default="ERRLOG.DAT",type=$outfile)
   qualifier BRIEF, nonnegatable
   qualifier ENTRY, nonnegatable
      value (required,list,type=ENTRY_KEYWORDS)
   qualifier EXCLUDE, nonnegatable
      value (required,list)
   qualifier FULL
   qualifier INCLUDE, nonnegatable
      value (required,list)
   qualifier LOG
   qualifier OUTPUT, nonnegatable, default
      value (default="SYS$OUTPUT",type=$outfile)
   qualifier NODE, nonnegatable
      value (list)
   qualifier PAGE
   qualifier REJECTED
      value (default="ERRLOG.REJ",type=$outfile)
   qualifier REGISTER_DUMP, nonnegatable
   qualifier SID_REGISTER, nonnegatable
      value (required,list)
   qualifier SINCE, nonnegatable
      value (default="TODAY",type=$datetime)
   qualifier STATISTICS, nonnegatable
   qualifier SUMMARY, nonnegatable
      value (list,type=SUMMARY_TYPE_KEYWORDS)

define type ENTRY_KEYWORDS
   keyword END
      value (type=$number)
   keyword START
      value (type=$number)

define type SUMMARY_TYPE_KEYWORDS
   keyword DEVICE
   keyword ENTRY
   keyword HISTOGRAM
   keyword MEMORY
   keyword VOLUME

define syntax ANALYZE_IMAGE
   image ANALYZOBJ
   parameter P1, label=FILE_SPECS, prompt="File(s)"
      value (required,list,type=$infile)
   qualifier ALPHA
   qualifier FIXUP_SECTION
      placement=positional
   qualifier GST
      placement=positional
   qualifier HEADER
      placement=positional
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$outfile)
   qualifier IMAGE, default
   qualifier INTERACTIVE
   qualifier PATCH_TEXT
      placement=positional
   qualifier SELECT, nonnegatable
      value (required,list,type=ANALIM_SELECT_OPTIONS)
   disallow (SELECT and FIXUP_SECTION)
   disallow (SELECT and INTERACTIVE)
   disallow (SELECT and PATCH_TEXT)
   disallow (SELECT and HEADER)
   disallow (SELECT and GST)

define type ANALIM_SELECT_OPTIONS
   keyword FILE_TYPE
   keyword ARCHITECTURE
   keyword IMAGE_TYPE
   keyword NAME
   keyword IDENTIFICATION
   keyword BUILD_IDENTIFICATION
   keyword LINK_TIME
  
define syntax ANALYZE_MEDIA
   image ANALYZBAD
   parameter P1, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier BAD_BLOCKS, nonnegatable
      value (list)
   qualifier EXERCISE
      value (list,type=EXER_KEYWORDS)
   qualifier LOG
   qualifier OUTPUT
      value (default="SYS$OUTPUT",type=$outfile)
   qualifier RETRY
   qualifier SHOW, nonnegatable
      value (list,type=SHOW_KEYWORDS)

define type EXER_KEYWORDS
   keyword FULL
   keyword KEEP, negatable
   keyword PATTERN
      value (list)

define type SHOW_KEYWORDS
   keyword BEFORE, negatable
   keyword AFTER, negatable

!define syntax ANALYZE_SYSTEM
!   image SDA
!   noparameters

define syntax ANALYZE_PROCESS_DUMP
   image ANALIMDMP
   parameter P1, prompt="File"
      value (required,type=$infile)
   qualifier IMAGE
      value (type=$outfile)
   qualifier NOIMAGE
   qualifier INTERACTIVE
   qualifier FULL
   qualifier MISCELLANEOUS
   qualifier RELOCATION
   qualifier OUTPUT
      value (default="SYS$OUTPUT",type=$outfile)

define verb APPEND
   image COPY
   parameter P1, label=INFILE, prompt="From"
      value (required,list,impcat,type=$infile)
   parameter P2, label=OUTFILE, prompt="To"
      value (required,type=$outfile)
   qualifier ALLOCATION
      value (required)
      placement=positional
   qualifier CONTIGUOUS
      placement=positional
   qualifier EXTENSION
      value (required)
      placement=positional
   qualifier FILE_MAXIMUM
      value (required,list)
      placement=positional
   qualifier NEW_VERSION
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
      placement=positional
   qualifier READ_CHECK
      placement=positional
   qualifier LOG
   qualifier WRITE_CHECK
      placement=positional
   qualifier CONFIRM
   qualifier EXCLUDE
      value (list)
   qualifier BEFORE
      value (default="TODAY")
   qualifier SINCE
      value (default="TODAY")
   qualifier CREATED
   qualifier MODIFIED
   qualifier EXPIRED
   qualifier BACKUP
   qualifier BY_OWNER
      value (type=$uic)
   qualifier APPLICATION_PROTOCOL
      value (required,type=PROTOCOL_TYPE)
   qualifier CHARACTER_SETS
      value (required,type=CHAR_SETS)
   qualifier DELETE_SOURCE
   qualifier INTAP1
   qualifier JOURNAL
   qualifier OSS_LOGGING
   qualifier PARAMETER
      value (required,type=OSI_PARAMS)
   qualifier SECURITY_GROUP
   qualifier STATE_LOGGING
   disallow (CHARACTER_SETS and not APPLICATION_PROTOCOL)
   disallow (DELETE_SOURCE and not APPLICATION_PROTOCOL)
   disallow (INTAP1 and not APPLICATION_PROTOCOL)
   disallow (JOURNAL and not APPLICATION_PROTOCOL)
   disallow (OSS_LOGGING and not APPLICATION_PROTOCOL)
   disallow (PARAMETER and not APPLICATION_PROTOCOL)
   disallow (SECURITY_GROUP and not APPLICATION_PROTOCOL)
   disallow (STATE_LOGGING and not APPLICATION_PROTOCOL)

define type PROTECTION
   keyword SYSTEM
      value
   keyword GROUP
      value
   keyword OWNER
      value
   keyword WORLD
      value

define type PROTOCOL_TYPE
   keyword FTAM, syntax=COPY_FTAM

define syntax COPY_FTAM
   image OSIF$COPY

define type CHAR_SETS
   keyword DEFAULT
   keyword NONE
   keyword JP_INTAP2
   keyword G1

define type OSI_PARAMS
   keyword CREATE_PASSWORD
      value (required)
   keyword CONCURRENCY_CONTROL
      value (required,list,type=CONCURRENCY)
   keyword COS
   keyword FILE_AVAIL
      value (required,type=FILE_AVAIL_TYPE)
   keyword SECURITY
      value (required,list,type=SECURITY_PARAMS)

define type CONCURRENCY
   keyword READ
      value
   keyword INSERT
      value
   keyword REPLACE
      value
   keyword EXTEND
      value
   keyword ERASE
      value
   keyword READ_ATTRIBUTE
      value
   keyword CHANGE_ATTRIBUTE
      value
   keyword DELETE_FILE
      value

define type FILE_AVAIL_TYPE
   keyword IMMEDIATE
   keyword DEFERRED

define type SECURITY_PARAMS
   keyword ACTION_LIST
      value (required,list,type=ACTIONS)
   keyword CONCURRENCY_ACCESS
      value (required,list,type=CONCURRENCY)
   keyword PASSWORD
      value (required,list,type=PASSWORDS)
   keyword IDENTITY
      value (required)
   keyword LEGAL
      value (required)

define type ACTIONS
   keyword READ
   keyword INSERT
   keyword REPLACE
   keyword EXTEND
   keyword ERASE
   keyword READ_ATTRIBUTE
   keyword CHANGE_ATTRIBUTE
   keyword DELETE_FILE

define type PASSWORDS
   keyword READ
      value
   keyword INSERT
      value
   keyword REPLACE
      value
   keyword EXTEND
      value
   keyword ERASE
      value
   keyword READ_ATTRIBUTE
      value
   keyword CHANGE_ATTRIBUTE
      value
   keyword DELETE_FILE
      value

define verb ASSIGN
   cliroutine ASSIGN
   parameter P1, prompt="Device"
      value (required,list,type=$old_file)
   parameter P2, prompt="Log name"
      value (required,type=$outlog)
   qualifier SYSTEM
   qualifier GROUP
   qualifier JOB
   qualifier PROCESS
   qualifier USER_MODE
   qualifier SUPERVISOR_MODE
   qualifier EXECUTIVE_MODE
   qualifier TABLE
      value (required)
   qualifier LOG
   qualifier NAME_ATTRIBUTES
      value (list,type=NAME_ATTR)
   qualifier TRANSLATION_ATTRIBUTES
      value (list,type=TRAN_ATTR)
      placement=positional

define type NAME_ATTR
   keyword CONFINE
   keyword NO_ALIAS

define type TRAN_ATTR
   keyword CONCEALED
   keyword TERMINAL

define verb ATTACH
   cliroutine ATTACH
   prefix CLI$K_ATTA_
   parameter P1, prompt="Process"
      value (required)
   qualifier IDENTIFICATION, syntax=ATTACH_BY_PID
      value (required)

define syntax ATTACH_BY_PID
   noparameters

define verb BACKUP
   image BACKUP
   parameter P1, label=INPUTS, prompt="From"
      value (required,list,type=$infile)
   parameter P2, label=OUTPUTS, prompt="To"
      value (required,list,type=$outfile)
   qualifier ALIAS, default
   qualifier ANALYZE, nonnegatable
   qualifier ASSIST, default
   qualifier BACKUP
   qualifier BEFORE
      value (required)
   qualifier BLOCK_SIZE
      value (required)
   qualifier BRIEF, nonnegatable
   qualifier BUFFER_COUNT
      value (required)
   qualifier BY_OWNER
      value (type=$uic)
      placement=local
   qualifier COMMENT
      value (required)
   qualifier COMPARE
   qualifier CONFIRM
   qualifier CRC, default
   qualifier CREATED
   qualifier DELETE
   qualifier DENSITY
      value (required)
   qualifier DISMOUNT, default
      value (type=DISMOUNT_TYPE)
   qualifier ENCRYPT
      value (list,type=ENCRYP_VAL)
   qualifier EXACT_ORDER
      placement=local
   qualifier EXCLUDE
      value (required,list,type=$infile)
   qualifier EXPIRED
   qualifier FAST
   qualifier FILEMERGE, nonnegatable
   qualifier FULL
   qualifier GROUP_SIZE
      value (required)
   qualifier IGNORE
      value (required,list,type=IGNORE_VAL_TYPE)
   qualifier IMAGE
   qualifier INCREMENTAL
   qualifier INITIALIZE
   qualifier INTERCHANGE
   qualifier JOURNAL
      value (type=$outfile)
   qualifier LABEL
      value (required,list)
   qualifier LIST, syntax=BACKUP_LIST, nonnegatable
      value
   qualifier LOG
   qualifier MEDIA_FORMAT
      value (required,type=MEDIA_FORMAT_TYPE)
   qualifier MODIFIED
   qualifier NEW_VERSION
   qualifier OVERLAY
   qualifier OWNER_UIC
      value (type=$uic)
      placement=local
   qualifier PHYSICAL
   qualifier PROTECTION
      value (list)
      placement=positional
   qualifier RECORD
   qualifier RELEASE_TAPE, nonnegatable
   qualifier REPLACE
   qualifier REWIND
   qualifier SAVE_SET
      placement=local
   qualifier SELECT
      value (required,list,type=$infile)
   qualifier SINCE
      value (default="TODAY")
   qualifier SNAPSHOT, nonnegatable
   qualifier STORAGE_MANAGEMENT, nonnegatable
      value (required,type=STORAGE_MANAGEMENT_TYPE)
   qualifier TAPE_EXPIRATION
      value (required,type=$datetime)
      placement=local
   qualifier TRUNCATE
   qualifier UNSHELVE
   qualifier VERIFY
   qualifier VOLUME
      value (required)
   qualifier SCRATCH, nonnegatable
      value (list,type=SCRATCH_KEYWORDS)
      placement=local
   qualifier CARTRIDGE, nonnegatable
      value (required,list,type=CART_KEYWORDS)
      placement=local
   qualifier DRIVE_CLASS, nonnegatable
      value (required)
      placement=local
   qualifier DISPOSITION, nonnegatable
      value (required,type=DISP_KEYWORDS)
      placement=local
   disallow (ENCRYPT.NAME and ENCRYPT.VALUE)
   disallow (DELETE and RECORD)
   disallow (DENSITY and MEDIA_FORMAT)
   disallow (CARTRIDGE.NAME and CARTRIDGE.MEDIA_NAME)
   disallow (CARTRIDGE.SIDE and not CARTRIDGE.NAME)
   disallow (DELETE and RECORD)
   disallow (DENSITY and MEDIA_FORMAT)
   disallow (SCRATCH and LABEL)
   disallow (SCRATCH and CARTRIDGE)
   disallow (SCRATCH and REWIND)
   disallow (COMPARE and DELETE)
   disallow (COMPARE and RECORD)
   disallow (ALIAS and IMAGE)
   disallow (ALIAS and PHYSICAL)

define type DISMOUNT_TYPE
   keyword UNLOAD, negatable, default

define type ENCRYP_VAL
   keyword NAME
      value (type=$outlog)
   keyword ALGORITHM
      value (default="DESCBC",type=$outlog)
   keyword VALUE
      value (list)

define type IGNORE_VAL_TYPE
   keyword ACCESSIBILITY
   keyword INTERLOCK
   keyword LABEL_PROCESSING
   keyword NOBACKUP

define syntax BACKUP_LIST
   parameter P1, label=INPUTS, prompt="From"
      value (list,type=$infile)
   parameter P2, label=OUTPUTS, prompt="To"
      value (list,type=$outfile)

define type MEDIA_FORMAT_TYPE
   keyword COMPACTION, negatable

define type STORAGE_MANAGEMENT_TYPE
   keyword V2SLS, default

define type SCRATCH_KEYWORDS
   keyword ASSIGNMENT_UNIT
      value (required,type=ASN_UNIT_KEYWORDS)
   keyword COLLECTION
      value (required)
   keyword MEDIA_NAME
      value (required)
   keyword LOCATION
      value (required)

define type ASN_UNIT_KEYWORDS
   keyword BASE_CARTRIDGE
   keyword COMPOUND_CARTRIDGE
   keyword PREASSIGNED_SIDE
   keyword SIDE

define type CART_KEYWORDS
   keyword NAME
      value (required)
   keyword SIDE
      value (required,type=$number)
   keyword MEDIA_NAME
      value (required)

define type DISP_KEYWORDS
   keyword KEEP
   keyword RELEASE

define verb CONTINUE
   synonym C
   cliroutine CONTINUE, cliflags(abbreviate, nostatus)

define verb CALL
   cliroutine CALL
   prefix CLI$K_CALL_
   parameter P1, prompt="Label "
      value (required)
   parameter P2
      value (type=$rest_of_line)
   qualifier OUTPUT
      value (type=$file)

define verb CANCEL
   cliroutine CANCEL
   parameter P1, prompt="File"
      value (type=$process)
   qualifier IDENTIFICATION
      value (required)

define verb CLOSE
   cliroutine CLOSE
   prefix CLI$K_CLOS_
   parameter P1, prompt="Log name"
      value (required,type=$inlog)
   qualifier END_OF_FILE
      value (required)
   qualifier ERROR
      value (required)
   qualifier LOG

define verb COPY
   image COPY
   parameter P1, label=INFILE, prompt="From"
      value (required,list,impcat,type=$infile)
   parameter P2, label=OUTFILE, prompt="To"
      value (required,type=$outfile)
   qualifier ALLOCATION
      value (required,list)
      placement=positional
   qualifier CONCATENATE, default
   qualifier CONTIGUOUS
      placement=positional
   qualifier EXTENSION
      value (required)
      placement=positional
   qualifier FILE_MAXIMUM
      value (required)
      placement=positional
   qualifier OVERLAY
      placement=positional
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
      placement=positional
   qualifier READ_CHECK
      placement=positional
   qualifier REPLACE
      placement=positional
   qualifier LOG
   qualifier VOLUME
      value (required)
   qualifier WRITE_CHECK
      placement=positional
   qualifier TRUNCATE
      placement=positional
   qualifier CONFIRM
   qualifier EXCLUDE
      value (list)
   qualifier BEFORE
      value (default="TODAY")
   qualifier SINCE
      value (default="TODAY")
   qualifier CREATED
   qualifier MODIFIED
   qualifier EXPIRED
   qualifier BACKUP
   qualifier BY_OWNER
      value (type=$uic)
   qualifier APPLICATION_PROTOCOL
      value (required,type=PROTOCOL_TYPE)
   qualifier CHARACTER_SETS
      value (required,type=CHAR_SETS)
   qualifier DELETE_SOURCE
   qualifier INTAP1
   qualifier JOURNAL
   qualifier OSS_LOGGING
   qualifier PARAMETER
      value (required,type=OSI_PARAMS)
   qualifier SECURITY_GROUP
   qualifier STATE_LOGGING
   disallow (CHARACTER_SETS and not APPLICATION_PROTOCOL)
   disallow (DELETE_SOURCE and not APPLICATION_PROTOCOL)
   disallow (INTAP1 and not APPLICATION_PROTOCOL)
   disallow (JOURNAL and not APPLICATION_PROTOCOL)
   disallow (OSS_LOGGING and not APPLICATION_PROTOCOL)
   disallow (PARAMETER and not APPLICATION_PROTOCOL)
   disallow (SECURITY_GROUP and not APPLICATION_PROTOCOL)
   disallow (STATE_LOGGING and not APPLICATION_PROTOCOL)

define verb CREATE
   image CREATE
   parameter P1, label=OUTPUT, prompt="File"
      value (required,list,impcat,type=$outfile)
   qualifier DIRECTORY
   qualifier OWNER_UIC
      value (required,type=$uic)
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier LOG
   qualifier VERSION_LIMIT
      value (required)
   qualifier VOLUME
      value (required)
   qualifier NAME_TABLE, syntax=NAME_TABLE
   qualifier ALLOCATION
      value (required,type=$number)
   disallow (ALLOCATION and not DIRECTORY)

define syntax NAME_TABLE
   cliroutine CRETABLE
   prefix CLI$K_CRET_
   parameter P1, prompt="Table name"
      value (required)
   qualifier USER_MODE
   qualifier SUPERVISOR_MODE
   qualifier EXECUTIVE_MODE
   qualifier ATTRIBUTES
      value (required,list,type=ATTRIBUTE_KEYWORDS)
   qualifier PARENT_TABLE
      value (required)
   qualifier QUOTA
      value (required,type=$number)
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier LOG

define type ATTRIBUTE_KEYWORDS
   keyword CONFINE
   keyword NO_ALIAS
   keyword SUPERSEDE

define verb DEALLOCATE
   cliroutine DEALLOCAT
   parameter P1, prompt="Device"
      value (required,type=$device)
   qualifier ALL, syntax=DEALLOCATE_ALL_DEVICES

define syntax DEALLOCATE_ALL_DEVICES
   noparameters

define verb DEASSIGN
   cliroutine DEASSIGN
   parameter P1, prompt="Log name"
      value (required,type=$inlog)
   qualifier SYSTEM
   qualifier GROUP
   qualifier JOB
   qualifier PROCESS
   qualifier USER_MODE
   qualifier SUPERVISOR_MODE
   qualifier EXECUTIVE_MODE
   qualifier TABLE
      value (required)
   qualifier ALL, syntax=DEASSIGN_ALL_NAMES
   qualifier QUEUE, syntax=DEASSIGN_QUEUE, nonnegatable

define syntax DEASSIGN_ALL_NAMES
   noparameters

define syntax DEASSIGN_QUEUE
   image QUEMAN
   parameter P1, prompt="Logical queue"
      value (required)
   qualifier QUEUE, default

define verb DECK
   cliroutine DECK, cliflags(nostatus)
   qualifier DOLLARS
      value

define verb DEFINE
   synonym DEF
   cliroutine DEFINE
   prefix CLI$K_DEFI_
   parameter P1, prompt="Log name"
      value (required,type=$outlog)
   parameter P2, prompt="Equ name"
      value (required,list,type=$old_file)
   qualifier SYSTEM
   qualifier GROUP
   qualifier JOB
   qualifier PROCESS
   qualifier USER_MODE
   qualifier SUPERVISOR_MODE
   qualifier EXECUTIVE_MODE
   qualifier TABLE
      value (required)
   qualifier LOG
   qualifier NAME_ATTRIBUTES
      value (list,type=NAME_ATTR)
   qualifier TRANSLATION_ATTRIBUTES
      value (list,type=TRAN_ATTR)
      placement=positional
   qualifier KEY, syntax=DEFINE_KEY

define syntax DEFINE_KEY
   cliroutine DEFKEY
   prefix CLI$K_DEFK_
   parameter P1, prompt="Key name"
      value (required)
   parameter P2, prompt="Equivalence name"
      value (required)
   qualifier ECHO
   qualifier TERMINATE
   qualifier LOCK_STATE
   qualifier IF_STATE
      value (required,list)
   qualifier SET_STATE
      value (required)
   qualifier LOG
   qualifier ERASE
   disallow (not LOCK_STATE and TERMINATE and SET_STATE)
   disallow (LOCK_STATE and not SET_STATE)

define verb DELETE
   image DELETE
   parameter P1, label=INPUT, prompt="File"
      value (required,list,impcat,type=$infile)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier CONFIRM
   qualifier CREATED
   qualifier ERASE
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier LOG
   qualifier MODIFIED
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier SYMBOL, syntax=DELETE_SYMBOL
      cliflags(mcrignore)
   qualifier BY_OWNER
      value (type=$uic)
   qualifier KEY, syntax=DELETE_KEY
      cliflags(mcrignore)


define syntax DELETE_SYMBOL
   cliroutine DELSYM
   prefix CLI$K_DLSY_
   parameter P1, prompt="Symbol"
      value (required,type=$insym)
   qualifier ALL, syntax=DELETE_ALL_SYMBOLS
   qualifier GLOBAL
   qualifier LOCAL
   qualifier LOG

define syntax DELETE_ALL_SYMBOLS
   noparameters

define syntax DELETE_KEY
   cliroutine DELKEY
   prefix CLI$K_DELK_
   parameter P1, prompt="Key name"
      value (required)
   qualifier LOG
   qualifier STATE
      value (required,list)
   qualifier ALL, syntax=DELETE_ALL_KEYS

define syntax DELETE_ALL_KEYS
   noparameters

define verb DEPOSIT
   cliroutine DEPOSIT, cliflags(nostatus, immediate)
   qualifier ASCII, nonnegatable
   qualifier BYTE, nonnegatable
   qualifier DECIMAL, nonnegatable
   qualifier HEXADECIMAL, nonnegatable
   qualifier LONG, nonnegatable
   qualifier OCTAL, nonnegatable
   qualifier WORD, nonnegatable

define verb DIRECTORY
   image DIRECTORY
   parameter P1, label=INPUT, prompt="File"
      value (list,impcat,type=$infile)
   qualifier ACL
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier BRIEF, nonnegatable, default
   qualifier BY_OWNER
      value (type=$uic)
   qualifier COLUMNS, default
      value (default="4")
   qualifier CREATED
   qualifier DATE
      value (list,type=DATE_OPTIONS)
   qualifier EFFECTIVE
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier FILE_ID
   qualifier FULL
   qualifier GRAND_TOTAL
   qualifier HEADING, default
   qualifier MODIFIED
   qualifier OUTPUT, default
      value (type=$file)
   qualifier OWNER
      value (type=OWNER_OPTIONS)
   qualifier PRINTER
   qualifier PROTECTION
   qualifier RECORDING
   qualifier SECURITY
   qualifier SELECT
      value (required,list,type=SELECT_OPTIONS)
   qualifier SHELVED_STATE
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier SIZE
      value (list,type=SIZE_OPTIONS)
   qualifier TIME
      value (list,type=DATE_OPTIONS)
   qualifier TOTAL
   qualifier TRAILING, default
   qualifier VERSIONS
      value (required)
   qualifier WIDTH, default
      value (list,type=WIDTH_OPTIONS)
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   qualifier SUPPRESS, default
   qualifier CACHING_ATTRIBUTE
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)

define type DATE_OPTIONS
   keyword ALL
   keyword CREATED, default
   keyword EXPIRED
   keyword MODIFIED
   keyword BACKUP
   keyword EFFECTIVE
   keyword RECORDING

define type OWNER_OPTIONS
   keyword IDENTIFIER

define type SELECT_OPTIONS
   keyword FILE
      value (list,type=SEL_FILE_OPTIONS)
   keyword SIZE, default
      value (list,type=SEL_SIZE_OPTIONS)
   keyword ACL, negatable
   keyword ONLINE, negatable
   keyword SHELVABLE, negatable

define type SEL_FILE_OPTIONS
   keyword NODE, negatable
   keyword DEVICE, negatable
   keyword DIRECTORY, negatable
   keyword NAME, negatable
   keyword TYPE, negatable
   keyword VERSION, negatable

define type SEL_SIZE_OPTIONS
   keyword MINIMUM_SIZE, default
      value (default="0")
   keyword MAXIMUM_SIZE, default
      value (default="1073741823")

define type SIZE_OPTIONS
   keyword ALL
   keyword ALLOCATION
   keyword USED, default

define type WIDTH_OPTIONS
   keyword DISPLAY, default
      value (default="0")
   keyword FILENAME, default
      value (default="19")
   keyword OWNER, default
      value (default="31")
   keyword SIZE, default
      value (default="7")

define type HIGHLIGHT_OPTIONS
   keyword REVERSE, label=HIGHLIGHT_REVERSE
   keyword BOLD, label=HIGHLIGHT_BOLD
   keyword BLINK, label=HIGHLIGHT_BLINK
   keyword UNDERLINE, label=HIGHLIGHT_UNDERLINE
   keyword BLUE, label=HIGHLIGHT_BLUE
   keyword CYAN, label=HIGHLIGHT_CYAN
   keyword GREEN, label=HIGHLIGHT_GREEN
   keyword MAGENTA, label=HIGHLIGHT_MAGENTA
   keyword RED, label=HIGHLIGHT_RED
   keyword YELLOW, label=HIGHLIGHT_YELLOW

define type PAGE_OPTIONS
   keyword CLEAR_SCREEN, label=PAGE_CLEAR_SCREEN
   keyword SCROLL, label=PAGE_SCROLL
   keyword SAVE, label=PAGE_SAVE
      value (type=$number)

define verb DISMOUNT
   image DISMOUNT
   parameter P1, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier UNLOAD, default
   qualifier UNIT
   qualifier ABORT
   qualifier CLUSTER
   qualifier OVERRIDE
      value (required,list,type=DISMOUNT_OVERRIDES)

define type DISMOUNT_OVERRIDES
   keyword CHECKS

define verb DUMP
   image DUMP
   parameter P1, label=INPUT, prompt="File"
      value (required,type=$infile)
   qualifier ALLOCATED
   qualifier ASCII
   qualifier BLOCKS
      value (list,type=DUMP_BLOCKS)
   qualifier BYTE
   qualifier DECIMAL
   qualifier DESCRIPTOR
      value (list,type=DESCR_OPTIONS)
   qualifier DIRECTORY
   qualifier EXACT
   qualifier FILE_HEADER
   qualifier FORMATTED, default
   qualifier HEADER
   qualifier HEXADECIMAL
   qualifier HIGHLIGHT, nonnegatable
      value (type=HIGHLIGHT_OPTIONS)
   qualifier IDENTIFIER
      value (list,type=$number)
   qualifier LONGWORD
   qualifier MEDIA_FORMAT
      value (list,type=CD_OPTIONS)
   qualifier NUMBER
      value (type=$number)
   qualifier OCTAL
   qualifier OUTPUT
      value (type=$outfile)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier PATH_TABLE
   qualifier PRINTER
   qualifier RECORDS
      value (list,type=DUMP_BLOCKS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier VALIDATE_HEADER
   qualifier WORD
   qualifier WRAP
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow (PAGE and (PRINTER or OUTPUT))
   disallow any2 (OCTAL, DECIMAL, HEXADECIMAL)
   disallow any2 (BYTE, WORD, LONGWORD)
   disallow (RECORDS and BLOCKS)
   disallow (PRINTER and OUTPUT)
   disallow (RECORDS and ALLOCATED)
   disallow (BLOCKS.END and BLOCKS.COUNT)
   disallow (RECORDS.END and RECORDS.COUNT)

define type DUMP_BLOCKS
   keyword START
      value (type=$number)
   keyword END
      value (type=$number)
   keyword COUNT
      value (type=$number)

define type DESCR_OPTIONS
   keyword BOOT
      value (type=$number)
   keyword PVD
      value (type=$number)
   keyword SVD
      value (type=$number)
   keyword VPD
      value (type=$number)
   keyword VDST
      value (type=$number)

define type CD_OPTIONS
   keyword CDROM
   keyword CDROM_HS

define verb EDIT
   image EDT
   parameter P1, label=INPUT, prompt="File"
      value (required,type=$infile)
   qualifier EDT
   qualifier READ_ONLY
   qualifier COMMAND, default
      value (type=$infile)
   qualifier OUTPUT
      value (type=$outfile)
   qualifier RECOVER
   qualifier JOURNAL, default
      value (type=$infile)
   qualifier CREATE, default
   qualifier $1_FILLER, label=DMY1
   qualifier $2_FILLER, label=DMY2

define verb ELSE
   cliroutine ELSE, cliflags(nostatus)
   parameter P1
      value (type=$rest_of_line)

define verb ENDIF
   cliroutine ENDIF, cliflags(nostatus)

define verb ENDSUBROUTINE
   cliroutine ENDSUBROUTINE
   noparameters

define verb EOD
   cliroutine EOD, cliflags(nostatus, immediate)

define verb EOJ
   cliroutine EOJ

define verb EXAMINE
   cliroutine EXAMINE, cliflags(nostatus, immediate)
   prefix CLI$K_EXAM_
   qualifier ASCII, nonnegatable
   qualifier BYTE, nonnegatable
   qualifier DECIMAL, nonnegatable
   qualifier HEXADECIMAL, nonnegatable
   qualifier LONG, nonnegatable
   qualifier OCTAL, nonnegatable
   qualifier WORD, nonnegatable

define verb EXIT
   cliroutine EXIT, cliflags(immediate)

define verb GOSUB
   cliroutine GOSUB
   parameter P1, prompt="label"
      value (required)

define verb GOTO
   cliroutine GOTO, cliflags(nostatus)
   parameter P1, prompt="Label"
      value (required)

define verb IF
   cliroutine IF, cliflags(nostatus, immediate)

define verb INITIALIZE
   image INIT
   parameter P1, label=DEVICE, prompt="Device"
      value (required,type=$device)
   parameter P2, label=VOLUME, prompt="Label"
      value (required)
   qualifier ACCESSED
      value (required,type=$number)
   qualifier BADBLOCKS
      value (required,list)
   qualifier CLUSTER_SIZE
      value (required,type=$number)
   qualifier COMPACTION
   qualifier DATA_CHECK
      value (list,type=DATACHECK_OPTIONS)
   qualifier DENSITY, label=QUAL_DENSITY
      value (required,type=MDFMT_DENSITIES)
   qualifier DIRECTORIES
      value (required,type=$number)
   qualifier ERASE
   qualifier EXTENSION
      value (required,type=$number)
   qualifier FILE_PROTECTION
      value (required,list,type=PROTECTION)
   qualifier GROUP
   qualifier HEADERS
      value (required,type=$number)
   qualifier HIGHWATER, default
   qualifier HOMEBLOCKS
      value (required,type=PLACEMENT)
   qualifier INDEX
      value (required)
   qualifier INTEGRITY
      value (required,type=$acl)
   qualifier INTERCHANGE
   qualifier LABEL
      value (required,list,type=ANSI)
   qualifier MAXIMUM_FILES
      value (required,type=$number)
   qualifier MEDIA_FORMAT
      value (required,list,type=MDFMT_OPTIONS)
   qualifier OVERRIDE
      value (required,list,type=INIT_OVERRIDES)
   qualifier OWNER_UIC
      value (required,type=$uic)
   qualifier POOL, nonnegatable
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier SECRECY, label=SECURITY
      value (required,type=$acl)
   qualifier SHARE, default
   qualifier SIZE
      value (required,type=$number)
   qualifier SQ1
      value (required)
   qualifier SQ2
      value (required)
   qualifier SQ3
      value (required)
   qualifier SQ4
      value (required)
   qualifier STRUCTURE
      value (required)
   qualifier SYSTEM
   qualifier USER_NAME
      value (required)
   qualifier VERIFIED, default
   qualifier WINDOWS
      value (required,type=$number)
   disallow (GROUP and SYSTEM)

define type DATACHECK_OPTIONS
   keyword READ
   keyword WRITE

define type MDFMT_DENSITIES
   keyword 800
   keyword 1600
   keyword 6250
   keyword SINGLE
   keyword DOUBLE
   keyword DD
   keyword HD
   keyword ED

define type PLACEMENT
   keyword GEOMETRY
   keyword FIXED
   keyword CONTIGUOUS

define type ANSI
   keyword VOLUME_ACCESSIBILITY
      value (required)
   keyword OWNER_IDENTIFIER
      value (required,type=$infile)

define type MDFMT_OPTIONS
   keyword DENSITY, label=MDFMT_DENSITY
      value (required,type=MDFMT_DENSITIES)
   keyword COMPACTION, label=MDFMT_COMPACTION, negatable

define type USER_ATTENDED
   keyword INTERRUPTION

define type INIT_OVERRIDES
   keyword EXPIRATION
   keyword ACCESSIBILITY
   keyword OWNER_IDENTIFIER

define verb INQUIRE
   cliroutine INQUIRE, cliflags(immediate)
   prefix CLI$K_INQU_
   qualifier GLOBAL, nonnegatable
   qualifier LOCAL, nonnegatable
   qualifier PUNCTUATION

define verb INSTALL
   image INSTALL
   parameter P1, label=INSTALL_DCL_COMMAND
      value (type=$rest_of_line)

define verb LOGOUT
   synonym LO
   cliroutine LOGOUT
   qualifier BRIEF
   qualifier FULL
   qualifier HANGUP

define verb MCR
   cliroutine MCR, cliflags(foreign)

define verb MOUNT
   image VMOUNT
   parameter P1, label=DEVICES, prompt="Device"
      value (required,list,type=$device)
   parameter P2, label=VOLUMES, prompt="Label"
      value (required,list)
   parameter P3, label=LOGNAMES, prompt="Log name"
      value (type=$outlog)
   qualifier ACCESSED
      value (required,type=$number)
   qualifier ASSIST, default
   qualifier AUTOMATIC, default
   qualifier BIND
      value (required)
   qualifier BLOCKSIZE
      value (required,type=$number)
   qualifier CACHE
      value (required,list,type=CACHE_OPTIONS)
   qualifier CLUSTER
   qualifier COMMENT
      value (required)
   qualifier CONFIRM
   qualifier COPY, default
   qualifier DATA_CHECK
      value (list,type=DATACHECK_OPTIONS)
   qualifier DENSITY
      value (required,type=$number)
   qualifier EXTENSION
      value (required,type=$number)
   qualifier FOREIGN, syntax=MOUNT_WO_LABEL, nonnegatable
   qualifier GROUP
   qualifier HDR3, default
   qualifier INCLUDE
   qualifier INITIALIZE
      value (required,type=INITIALIZE_OPTIONS)
   qualifier INTEGRITY
      value (required,type=$acl)
   qualifier LABEL, nonnegatable, default
   qualifier NOLABEL, syntax=MOUNT_WO_LABEL, nonnegatable
   qualifier MEDIA_FORMAT
      value (required,list,type=MDFMT_OPTIONS)
   qualifier MESSAGE, default
   qualifier MOUNT_VERIFICATION, default
   qualifier MULTI_VOLUME
   qualifier OVERRIDE
      value (required,list,type=MOUNT_OVERRIDES)
   qualifier OWNER_UIC
      value (required,type=$uic)
   qualifier POOL
   qualifier PROCESSOR
      value (required)
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier QUOTA, default
   qualifier REBUILD, default
   qualifier RECORDSIZE
      value (required,type=$number)
   qualifier SECRECY, label=SECURITY
      value (required,type=$acl)
   qualifier SHARE
   qualifier SHADOW, nonnegatable
      value (required,list)
      placement=local
   qualifier SQ1
      value (required)
   qualifier SQ2
      value (required)
   qualifier SQ3
      value (required)
   qualifier SQ4
      value (required)
   qualifier SUBSYSTEM
   qualifier SYSTEM
   qualifier UCS_SEQUENCE
      value (required)
   qualifier UNDEFINED_FAT
      value (required,type=UNDEF_FAT_OPTIONS)
   qualifier UNLOAD, default
   qualifier WINDOWS
      value (required,type=$number)
   qualifier WRITE, default
   qualifier SCRATCH, syntax=MME_MOUNT
      value (list,type=SCRATCH_KEYWORDS)
   qualifier CARTRIDGE, syntax=MME_MOUNT
      value (required,list,type=CART_KEYWORDS)
   qualifier DRIVE_CLASS, syntax=MME_MOUNT
      value (required)
   qualifier LOGICAL_NAME
      value (required,type=$outlog)
   qualifier DISPOSITION
      value (required,type=DISP_KEYWORDS)
   qualifier TAPE_EXPIRATION, nonnegatable
      value (required,type=$datetime)
   disallow ((GROUP or SYSTEM) and SHARE)
   disallow (LABEL and NOLABEL)
   disallow (SYSTEM and GROUP)
   disallow (COPY and CONFIRM)
   disallow ((COPY or neg COPY) and not SHADOW)
   disallow ((CONFIRM or neg CONFIRM) and not SHADOW)
   disallow (INCLUDE and not SHADOW)
   disallow (MULTI_VOLUME and (not FOREIGN or LABEL))
   disallow (MEDIA_FORMAT and DENSITY)
   disallow (LOGICAL_NAME and LOGNAMES)
   disallow (POOL and (CACHE or SYSTEM or GROUP or FOREIGN))

define type CACHE_OPTIONS
   keyword EXTENT, negatable
      value (required,type=$number)
   keyword FILE_ID, negatable
      value (required,type=$number)
   keyword LIMIT
      value (required,type=$number)
   keyword QUOTA, negatable
      value (required,type=$number)
   keyword WRITETHROUGH
   keyword TAPE_DATA

define syntax MOUNT_WO_LABEL
   parameter P1, label=DEVICES, prompt="Device"
      value (required,list,type=$device)
   parameter P2, label=VOLUMES, prompt="Label"
      value (list)
   parameter P3, label=LOGNAMES, prompt="Log name"
      value (type=$outlog)
   disallow ((<MOUNT>FOREIGN or <MOUNT>NOLABEL) and (<MOUNT>ACCESSED or 
      <MOUNT>AUTOMATIC or <MOUNT>BIND or <MOUNT>CONFIRM or neg 
      <MOUNT>CONFIRM or <MOUNT>COPY or neg <MOUNT>COPY or <MOUNT>EXTENSION or 
      <MOUNT>HDR3 or <MOUNT>INITIALIZE or <MOUNT>LABEL or <MOUNT>PROCESSOR or 
      <MOUNT>QUOTA or <MOUNT>REBUILD or <MOUNT>TAPE_EXPIRATION or 
      <MOUNT>WINDOWS))
   disallow ((<MOUNT>GROUP or <MOUNT>SYSTEM) and <MOUNT>SHARE)
   disallow (<MOUNT>SYSTEM and <MOUNT>GROUP)
   disallow (<MOUNT>LOGICAL_NAME and <MOUNT>LOGNAMES)
   disallow (<MOUNT>SCRATCH and neg <MOUNT>WRITE)
   disallow (<MOUNT>FOREIGN and <MOUNT>SHADOW)

define type INITIALIZE_OPTIONS
   keyword ALL
   keyword CONTINUATION

define type MOUNT_OVERRIDES
   keyword ACCESSIBILITY
   keyword EXPIRATION
   keyword IDENTIFICATION, syntax=MOUNT_WO_LABEL
   keyword NO_FORCED_ERROR
   keyword SETID
   keyword LOCK
   keyword OWNER_IDENTIFIER
   keyword SHADOW_MEMBERSHIP
   keyword SECURITY
   keyword LIMITED_SEARCH

define type UNDEF_FAT_OPTIONS
   keyword FIXED
      value (required,type=UNDEF_RAT_OPTIONS)
   keyword VARIABLE
      value (required,type=UNDEF_RAT_OPTIONS)
   keyword LSB_VARIABLE
      value (required,type=UNDEF_RAT_OPTIONS)
   keyword MSB_VARIABLE
      value (required,type=UNDEF_RAT_OPTIONS)
   keyword STREAM
      value (type=$number)
   keyword STREAM_LF
      value (type=$number)
   keyword STREAM_CR
      value (type=$number)

define type UNDEF_RAT_OPTIONS
   keyword NONE
      value (type=$number)
   keyword CR
      value (type=$number)
   keyword FTN
      value (type=$number)
   keyword PRN
      value (type=$number)
   keyword NOBKS
      value (type=$number)
   keyword MSB
      value (type=$number)

define syntax MME_MOUNT
   parameter P1, label=DEVICES, prompt="Device"
      value (list,type=$device)
   disallow ((<MOUNT>FOREIGN or <MOUNT>NOLABEL) and (<MOUNT>ACCESSED or 
      <MOUNT>AUTOMATIC or <MOUNT>BIND or <MOUNT>CONFIRM or neg 
      <MOUNT>CONFIRM or <MOUNT>COPY or neg <MOUNT>COPY or <MOUNT>EXTENSION or 
      <MOUNT>HDR3 or <MOUNT>INITIALIZE or <MOUNT>LABEL or <MOUNT>PROCESSOR or 
      <MOUNT>QUOTA or <MOUNT>REBUILD or <MOUNT>WINDOWS or <MOUNT>TAPE_EXPIRATION))
   disallow ((<MOUNT>GROUP or <MOUNT>SYSTEM) and <MOUNT>SHARE)
   disallow (<MOUNT>SYSTEM and <MOUNT>GROUP)
   disallow (<MOUNT>CARTRIDGE and <MOUNT>SCRATCH)
   disallow (<MOUNT>DRIVE_CLASS and DEVICES)
   disallow (<MOUNT>CARTRIDGE.NAME and <MOUNT>CARTRIDGE.MEDIA_NAME)
   disallow (<MOUNT>CARTRIDGE.SIDE and not <MOUNT>CARTRIDGE.NAME)
   disallow (<MOUNT>LOGICAL_NAME and <MOUNT>LOGNAMES)
   disallow (<MOUNT>SCRATCH and neg <MOUNT>WRITE)

define verb ON
   cliroutine ON, cliflags(immediate)

define verb OPEN
   cliroutine OPEN
   prefix CLI$K_OPEN_
   parameter P1, prompt="Log name"
      value (required,type=$outlog)
   parameter P2, prompt="File"
      value (required,type=$infile)
   qualifier END_OF_FILE
      value (required)
   qualifier ERROR
      value (required)
   qualifier READ, nonnegatable
   qualifier WRITE, nonnegatable
   qualifier SHARE, nonnegatable
      value (type=SHARE_OPTIONS)
   qualifier APPEND, nonnegatable
   disallow (WRITE and APPEND)

define type SHARE_OPTIONS
   keyword READ
   keyword WRITE

define verb PURGE
   image DELETE
   parameter P1, label=INPUT, prompt="File"
      value (list,impcat,default="*.*",type=$infile)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier CONFIRM
   qualifier CREATED
   qualifier ERASE
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier KEEP
      value (required)
   qualifier LOG
   qualifier MODIFIED
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier BY_OWNER
      value (type=$uic)

define verb RUN
   synonym R
   synonym RU
   cliroutine RUN, cliflags(abbreviate)
   prefix CLI$K_RUN_
   parameter P1, prompt="File"
      value (required,type=$infile)
   qualifier DELAY, syntax=RUN_PROCESS
      value (required,type=$deltatime)
   qualifier ERROR, syntax=RUN_PROCESS
      value (required,type=$outfile)
   qualifier INPUT, syntax=RUN_PROCESS
      value (required,type=$outfile)
   qualifier INTERVAL, syntax=RUN_PROCESS
      value (required,type=$deltatime)
   qualifier OUTPUT, syntax=RUN_PROCESS
      value (required,type=$outfile)
   qualifier PRIORITY, syntax=RUN_PROCESS
      value (required)
   qualifier PRIVILEGES, syntax=RUN_PROCESS
      value (required,list,type=PRIVILEGES)
   qualifier PROCESS_NAME, syntax=RUN_PROCESS
      value (required)
   qualifier RESOURCE_WAIT, syntax=RUN_PROCESS, default
   qualifier SCHEDULE, syntax=RUN_PROCESS
      value (required,type=$datetime)
   qualifier SERVICE_FAILURE, syntax=RUN_PROCESS
   qualifier SWAPPING, syntax=RUN_PROCESS, default
   qualifier UIC, syntax=RUN_PROCESS
      value (required,type=$uic)
   qualifier ACCOUNTING, syntax=RUN_PROCESS, default
   qualifier BUFFER_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier TIME_LIMIT, syntax=RUN_PROCESS
      value (required,type=$deltatime)
   qualifier FILE_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier PAGE_FILE, syntax=RUN_PROCESS
      value (required)
   qualifier QUEUE_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier SUBPROCESS_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier MAXIMUM_WORKING_SET, syntax=RUN_PROCESS
      value (required)
   qualifier WORKING_SET, syntax=RUN_PROCESS
      value (required)
   qualifier DEBUG
   qualifier AUTHORIZE, syntax=RUN_PROCESS
   qualifier MAILBOX, syntax=RUN_PROCESS
      value (required)
   qualifier AST_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier IO_BUFFERED, syntax=RUN_PROCESS
      value (required)
   qualifier IO_DIRECT, syntax=RUN_PROCESS
      value (required)
   qualifier ENQUEUE_LIMIT, syntax=RUN_PROCESS
      value (required)
   qualifier EXTENT, syntax=RUN_PROCESS
      value (required)
   qualifier DETACHED, syntax=RUN_PROCESS, nonnegatable
   qualifier DUMP, syntax=RUN_PROCESS
   qualifier JOB_TABLE_QUOTA, syntax=RUN_PROCESS
      value (required)
   qualifier TRUSTED, syntax=RUN_PROCESS
   qualifier ON, syntax=RUN_PROCESS
      value (required)

define syntax RUN_PROCESS
   image RUNDET

define type PRIVILEGES
   keyword ACNT, negatable
   keyword ALLSPOOL, negatable
   keyword ALTPRI, negatable
   keyword AUDIT, negatable
   keyword BUGCHK, negatable
   keyword BYPASS, negatable
   keyword CMEXEC, negatable
   keyword CMKRNL, negatable
   keyword DETACH, negatable
   keyword DIAGNOSE, negatable
   keyword DOWNGRADE, negatable
   keyword EXQUOTA, negatable
   keyword GROUP, negatable
   keyword GRPNAM, negatable
   keyword GRPPRV, negatable
   keyword IMPORT, negatable
   keyword LOG_IO, negatable
   keyword MOUNT, negatable
   keyword NETMBX, negatable
   keyword OPER, negatable
   keyword PFNMAP, negatable
   keyword PHY_IO, negatable
   keyword PRMCEB, negatable
   keyword PRMGBL, negatable
   keyword PRMJNL, negatable
   keyword PRMMBX, negatable
   keyword PSWAPM, negatable
   keyword SAME, negatable
   keyword READALL, negatable
   keyword SECURITY, negatable
   keyword SETPRV, negatable
   keyword SHARE, negatable
   keyword SHMEM, negatable
   keyword SYSLCK, negatable
   keyword SYSGBL, negatable
   keyword SYSNAM, negatable
   keyword SYSPRV, negatable
   keyword TMPJNL, negatable
   keyword TMPMBX, negatable
   keyword UPGRADE, negatable
   keyword VOLPRO, negatable
   keyword WORLD, negatable

define verb READ
   cliroutine READ
   prefix CLI$K_READ_
   parameter P1, prompt="Log name"
      value (required,type=$inlog)
   parameter P2, prompt="Symbol"
      value (required,type=$outfile)
   qualifier END_OF_FILE
      value (required)
   qualifier ERROR
      value (required)
   qualifier KEY
      value (required,list)
   qualifier INDEX
      value (required)
   qualifier DELETE
   qualifier LOCK, default
   qualifier PROMPT, nonnegatable
      value (required)
   qualifier MATCH
      value (required,type=MATCH_KEYS)
   qualifier TIME_OUT
      value (required,type=$number)

define type MATCH_KEYS
   keyword EQ
   keyword GE
   keyword GT

define verb RECALL
   cliroutine RECALL, cliflags(nostatus)
   prefix CLI$K_RCAL_
   parameter P1
      value (type=$rest_of_line)
   qualifier ALL, syntax=RECALL_ALL_COMMANDS, nonnegatable
   qualifier ERASE, syntax=RECALL_ALL_COMMANDS
   qualifier OUTPUT, syntax=RECALL_ALL_COMMANDS, nonnegatable
      value (required,type=$file)
   qualifier INPUT, syntax=RECALL_ALL_COMMANDS, nonnegatable
      value (required,type=$file)
   qualifier PAGE, syntax=RECALL_ALL_COMMANDS
   disallow ((ALL or PAGE) and (OUTPUT or INPUT))

define syntax RECALL_ALL_COMMANDS
   cliroutine RECALL
   noparameters

define verb RENAME
   image RENAME
   parameter P1, prompt="From"
      value (required,list,impcat,type=$infile)
   parameter P2, prompt="To"
      value (required,type=$outfile)
   qualifier NEW_VERSION, default
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier CREATED
   qualifier MODIFIED
   qualifier EXPIRED
   qualifier BACKUP
   qualifier EXCLUDE
      value (required,list)
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CONFIRM
   qualifier LOG
   qualifier INHERIT_SECURITY

define verb RETURN
   cliroutine RETURN, cliflags(immediate)

define verb SEARCH
   image SEARCH
   parameter P1, label=SOURCE, prompt="Filename(s)"
      value (required,list,type=$infile)
   parameter P2, label=STRING, prompt="String(s)"
      value (required,list)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CONFIRM
   qualifier CREATED
   qualifier EXACT
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier FORMAT, nonnegatable, default
      value (default="TEXT",type=SEARCH_FORMATS)
   qualifier HEADING, default
   qualifier HIGHLIGHT
      value (type=HIGHLIGHT_MODES)
   qualifier LOG
   qualifier MATCH, nonnegatable, default
      value (default="OR",type=SEARCH_MATCHES)
   qualifier MODIFIED
   qualifier NUMBERS
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$outfile)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier REMAINING
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier STATISTICS
   qualifier WINDOW
      value (list,default="5")
   qualifier WRAP
   qualifier WARNINGS, default
   qualifier KEY, nonnegatable
      value (required,list,type=KEY_OPTIONS)
      placement=positional
   disallow (OUTPUT and PAGE)
   disallow (WRAP and not PAGE)

define type SEARCH_FORMATS
   keyword PASSALL
   keyword TEXT, default
   keyword NOFF
   keyword DUMP
   keyword NONULLS

define type HIGHLIGHT_MODES
   keyword REVERSE
   keyword BOLD, default
   keyword BLINK
   keyword UNDERLINE
   keyword HARDCOPY
      value (type=HARDCOPY_MODES)

define type HARDCOPY_MODES
   keyword OVERSTRIKE
   keyword UNDERLINE, default

define type SEARCH_MATCHES
   keyword AND
   keyword OR, default
   keyword NAND
   keyword NOR
   keyword XOR
   keyword EQV

define type KEY_OPTIONS
   keyword POSITION, label=KEY_POSITION
      value (type=$number)
   keyword SIZE, label=KEY_SIZE
      value (type=$number)
$ EOD
$	set command /table=sys$scratch:dcltbl_'f$getjpi("","PID") -
        	/out=sys$scratch:dcltbl_'f$getjpi("","PID") -
        	sys$input
$ DECK
define verb SET
   image SET
   parameter P1, label=OPTION, prompt="What"
      value (required,type=SET_OPTIONS)

define type SET_OPTIONS
   keyword ACL, syntax=SET_ACL
   keyword BROADCAST, syntax=SET_BROADCAST
      value (required,list,type=BRDCST_TYPES)
   keyword CARD_READER, syntax=SET_CARD_READER
   keyword CLUSTER, syntax=SET_CLUSTER
   keyword DEVICE, syntax=SET_DEVICE
   keyword DEFAULT, syntax=SET_DEFAULT
   keyword DIRECTORY, syntax=SET_DIRECTORY
   keyword FILE, syntax=SET_FILE
   keyword LOGINS, syntax=SET_LOGINS
   keyword MAGTAPE, syntax=SET_MAGTAPE
   keyword ON, syntax=SET_ON, negatable
   keyword PROCESS, syntax=SET_PROCESS
   keyword PROTECTION, syntax=SET_PROTECTION
      value (list,type=PROTECTION)
   keyword TERMINAL, syntax=SET_TERMINAL
   keyword UIC, syntax=SET_UIC
      cliflags(mcroptdelim)
   keyword VERIFY, syntax=SET_VERIFY, negatable
      value (list,type=VERIFY_KEYS)
   keyword VOLUME, syntax=SET_VOLUME
   keyword WORKING_SET, syntax=SET_WORKING_SET
   keyword RMS_DEFAULT, syntax=SET_RMS_DEFAULT
   keyword CONTROL_Y, syntax=SET_CONTROL, negatable
      value (list,type=CONTROL_KEYS)
   keyword TIME, syntax=SET_TIME
      value
   keyword HOST, syntax=SET_HOST
   keyword COMMAND, syntax=SET_COMMAND
   keyword DAY, syntax=SET_DAY
   keyword PROMPT, syntax=SET_PROMPT
      value
   keyword PREFIX, syntax=SET_PREFIX, negatable
   keyword KEY, syntax=SET_KEY
   keyword OUTPUT_RATE, syntax=SET_OUTPUT_RATE
      value (type=$deltatime)
   keyword SYMBOL, syntax=SET_SYMBOL
   keyword WATCH, syntax=SET_WATCH
   keyword SECURITY, syntax=SET_SECURITY

define syntax SET_ACL
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Object"
      value (required)
   qualifier ACL
      value (list,type=$acl)
   qualifier AFTER
      value (required,type=$acl)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY")
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CONFIRM
   qualifier CREATED
   qualifier DEFAULT
   qualifier DELETE
      value (type=SET_ACL_DELETE)
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier LIKE
      value (required,list,type=SET_ACL_LIKE)
   qualifier LOG
   qualifier MODIFIED
   qualifier NEW
   qualifier OBJECT_TYPE
      value (type=ACL_OBJECTS)
   qualifier CLASS
      value (required)
   qualifier REPLACE
      value (required,list,type=$acl)
   qualifier SINCE
      value (default="TODAY")
   disallow (AFTER and REPLACE)
   disallow ((AFTER or REPLACE) and not ACL)
   disallow ((AFTER or REPLACE or NEW or LIKE) and DELETE)
   disallow ((AFTER or REPLACE or LIKE or DELETE) and NEW)
   disallow ((AFTER or REPLACE or NEW or DELETE) and LIKE)
   disallow (CLASS and OBJECT_TYPE)
   disallow any2 (AFTER, DELETE, LIKE, NEW, REPLACE)

define type SET_ACL_DELETE
   keyword ALL

define type ACL_OBJECTS
   keyword FILE
   keyword DEVICE
   keyword QUEUE
   keyword COMMON_EVENT_CLUSTER
   keyword LOGICAL_NAME_TABLE
   keyword PROCESS
   keyword SYSTEM_GLOBAL_SECTION
   keyword GROUP_GLOBAL_SECTION
   keyword CAPABILITY
   keyword RESOURCE_DOMAIN
   keyword VOLUME

define type KEEP_FILE
   keyword RECOVERY
   keyword JOURNAL

define type MODE_TYPES
   keyword PROMPT, negatable, default

define type SECUR_PROFILE
   keyword TEMPLATE
      value
   keyword ACCESS

define type SET_ACL_LIKE
   keyword OBJECT_NAME
      value (required)
   keyword OBJECT_TYPE
      value (required,type=ACL_OBJECTS)
   keyword NAME
      value (required)
   keyword CLASS
      value (required)

define type BRDCST_TYPES
   keyword ALL
   keyword NONE
   keyword GENERAL, negatable
   keyword PHONE, negatable
   keyword MAIL, negatable
   keyword QUEUE, negatable
   keyword SHUTDOWN, negatable
   keyword URGENT, negatable
   keyword DCL, negatable
   keyword OPCOM, negatable
   keyword USER1, negatable
   keyword USER2, negatable
   keyword USER3, negatable
   keyword USER4, negatable
   keyword USER5, negatable
   keyword USER6, negatable
   keyword USER7, negatable
   keyword USER8, negatable
   keyword USER9, negatable
   keyword USER10, negatable
   keyword USER11, negatable
   keyword USER12, negatable
   keyword USER13, negatable
   keyword USER14, negatable
   keyword USER15, negatable
   keyword USER16, negatable

define syntax SET_BROADCAST
   parameter P1, label=OPTION
      value (required,list,type=SET_OPTIONS)
   noqualifiers

define syntax SET_CARD_READER
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier 026
   qualifier 029
   qualifier LOG

define syntax SET_CLUSTER
   qualifier QUORUM, nonnegatable
      value
   qualifier EXPECTED_VOTES, nonnegatable
      value
   disallow (QUORUM and EXPECTED_VOTES)

define syntax SET_DEVICE
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=FILE, prompt="Device"
      value (required,type=$device)
   qualifier SPOOLED
      value (list)
   qualifier ERROR_LOGGING
   qualifier AVAILABLE
   qualifier DUAL_PORT
   qualifier LOG
   qualifier SERVED, nonnegatable
   qualifier DIAGNOSTIC
   qualifier ACL, syntax=SET_DEV_ACL, nonnegatable
      value (list,type=$acl)
   qualifier AFTER
      value (required,type=$acl)
   qualifier DEFAULT
   qualifier DELETE
      value (type=SET_ACL_DELETE)
   qualifier LIKE
      value (required,type=$device)
   qualifier NEW
   qualifier REPLACE
      value (required,list,type=$acl)
   disallow ((AFTER or DELETE or LIKE or NEW or REPLACE) and not 
      ACL)
   disallow any2 (AFTER, DELETE, LIKE, NEW, REPLACE)
   disallow (AFTER and REPLACE)
   disallow ((AFTER or REPLACE or NEW or LIKE) and DELETE)
   disallow ((AFTER or REPLACE or LIKE or DELETE) and NEW)
   disallow ((AFTER or REPLACE or NEW or DELETE) and LIKE)

define syntax SET_DEV_ACL
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Device"
      value (required,list,type=$infile)


define syntax SET_DEFAULT
   cliroutine SETDEFALT
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="Directory"
      value (required,type=$directory)
   noqualifiers

define syntax SET_DIRECTORY
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DIRECTORY, prompt="Directory"
      value (required,list,impcat,type=$directory)
   qualifier CONFIRM
   qualifier LOG
   qualifier OWNER_UIC
      value (type=$uic)
   qualifier VERSION_LIMIT, nonnegatable
      value
   qualifier EXCLUDE
      value (required,list)
   qualifier BEFORE
      value (default="TODAY")
   qualifier SINCE
      value (default="TODAY")
   qualifier BACKUP
   qualifier CREATED
   qualifier MODIFIED
   qualifier EXPIRED
   qualifier BY_OWNER
      value (type=$uic)
   qualifier ACL, syntax=SET_DIR_ACL, nonnegatable
      value (list,type=$acl)
   qualifier AFTER
      value (required,type=$acl)
   qualifier DEFAULT
   qualifier DELETE
      value (type=SET_ACL_DELETE)
   qualifier LIKE
      value (required,type=$infile)
   qualifier NEW
   qualifier REPLACE
      value (required,list,type=$acl)
   disallow ((AFTER or DELETE or LIKE or NEW or REPLACE) and not 
      ACL)
   disallow any2 (AFTER, DELETE, LIKE, NEW, REPLACE)
   disallow (AFTER and REPLACE)
   disallow ((AFTER or REPLACE or NEW or LIKE) and DELETE)
   disallow ((AFTER or REPLACE or LIKE or DELETE) and NEW)
   disallow ((AFTER or REPLACE or NEW or DELETE) and LIKE)

define syntax SET_DIR_ACL
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Directory"
      value (required,list,type=$infile)

define syntax SET_FILE
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=FILE, prompt="File"
      value (required,list,impcat,type=$infile)
   qualifier ATTRIBUTES
      value (required,list,type=FILE_ATTRIBUTES)
   qualifier BACKUP
   qualifier CONFIRM
   qualifier DATA_CHECK
      value (list)
   qualifier END_OF_FILE
   qualifier ENTER
      value (required,type=$infile)
   qualifier ERASE_ON_DELETE
   qualifier EXPIRATION_DATE
      value (required,type=$datetime)
   qualifier EXTENSION
      value
   qualifier GLOBAL_BUFFERS
      value (required)
   qualifier AI_JOURNAL
      value (list,type=LONG_TERM_JOURNAL_KEYWORDS)
   qualifier BI_JOURNAL
      value (list,type=LONG_TERM_JOURNAL_KEYWORDS)
   qualifier RU_JOURNAL
      value (type=RU_JOURNAL_KEYWORDS)
   qualifier RU_ACTIVE
      value (required)
   qualifier RU_FACILITY
      value (required)
   qualifier LOG
   qualifier NODIRECTORY, nonnegatable
   qualifier OWNER_UIC
      value (type=$infile)
   qualifier RECORD_PROTECTION
      value
   qualifier SHELVABLE
   qualifier STATISTICS
   qualifier TRUNCATE
   qualifier REMOVE
   qualifier VERSION_LIMIT, nonnegatable
      value
   qualifier EXCLUDE
      value (required,list)
   qualifier BEFORE
      value (default="TODAY")
   qualifier SINCE
      value (default="TODAY")
   qualifier CREATED
   qualifier MODIFIED
   qualifier BY_OWNER
      value (type=$uic)
   qualifier ACL, syntax=SET_FILE_ACL, nonnegatable
      value (list,type=$acl)
   qualifier AFTER
      value (required,type=$acl)
   qualifier DEFAULT
   qualifier DELETE
      value (type=SET_ACL_DELETE)
   qualifier LIKE
      value (required,type=$infile)
   qualifier NEW
   qualifier REPLACE
      value (required,list,type=$acl)
   qualifier SEMANTICS
      value (required,type=$infile)
   qualifier UNLOCK
   qualifier PROTECTION
      value (list,type=PROTECTION)
   qualifier MOVE
   disallow ((AFTER or DELETE or LIKE or NEW or REPLACE) and not 
      ACL)
   disallow any2 (AFTER, DELETE, LIKE, NEW, REPLACE)
   disallow (AFTER and REPLACE)
   disallow ((AFTER or REPLACE or NEW or LIKE) and DELETE)
   disallow ((AFTER or REPLACE or LIKE or DELETE) and NEW)
   disallow ((AFTER or REPLACE or NEW or DELETE) and LIKE)

define type FILE_ATTRIBUTES
   keyword ORG
      value (required,type=ORGANIZATION)
   keyword RFM
      value (required,type=RECORD_FORMAT)
   keyword RAT
      value (required,list,type=RECORD_ATTRIBUTES)
   keyword LRL
      value (required,type=$number)
   keyword HBK
      value (required,type=$number)
   keyword EBK
      value (required,type=$number)
   keyword FFB
      value (required,type=$number)
   keyword BKS
      value (required,type=$number)
   keyword FSZ
      value (required,type=$number)
   keyword MRS
      value (required,type=$number)
   keyword DEQ
      value (required,type=$number)
   keyword GBC
      value (required,type=$number)
   keyword VRS
      value (required,type=$number)

define type ORGANIZATION
   keyword SEQ
   keyword REL
   keyword IDX

define type RECORD_FORMAT
   keyword UDF
   keyword FIX
   keyword VAR
   keyword VFC
   keyword STM
   keyword STMCR
   keyword STMLF

define type RECORD_ATTRIBUTES
   keyword NONE
   keyword BLK, negatable
   keyword CR
   keyword FTN
   keyword PRN
   keyword MSB

define type LONG_TERM_JOURNAL_KEYWORDS
   keyword CREATE, negatable
   keyword FILE
      value (required,type=$infile)
   keyword ALLOCATION
      value (required,type=$number)
   keyword EXTENSION
      value (required,type=$number)

define type RU_JOURNAL_KEYWORDS
   keyword DEVICE
      value (required,type=$device)
   keyword LABEL
      value (required)

define syntax SET_FILE_ACL
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="File"
      value (required,list,type=$infile)

define syntax SET_LOGINS
   parameter P1, label=OPTION
      value (required)
   qualifier INTERACTIVE
      value

define syntax SET_MAGTAPE
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier DENSITY
      value (required)
   qualifier MEDIA_FORMAT
      value (required,type=SET_MT_MDFMT_OPT)
   qualifier RETENSION
   qualifier REWIND
   qualifier UNLOAD
   qualifier LOGSOFT
   qualifier LOG
   qualifier END_OF_FILE
   qualifier SKIP
      value (required,type=SKIPTYPES)
   disallow (RETENSION and (not REWIND and not UNLOAD))

define type SET_MT_MDFMT_OPT
   keyword COMPACTION, negatable

define type SKIPTYPES
   keyword END_OF_TAPE
   keyword FILES
      value
   keyword BLOCKS
      value
   keyword RECORDS
      value

define syntax SET_ON
   cliroutine SETON
   parameter P1, label=OPTION
      value (required)
   noqualifiers

define syntax SET_PRINTER
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier CR
   qualifier FF
   qualifier UPPERCASE
   qualifier LOWERCASE
   qualifier LA11, nonnegatable
   qualifier LA180, nonnegatable
   qualifier LP11, nonnegatable
   qualifier PAGE, nonnegatable, default
      value
   qualifier UNKNOWN, nonnegatable
   qualifier WIDTH, nonnegatable, default
      value
   qualifier PASSALL
   qualifier FALLBACK
   qualifier DAVFU
   qualifier FORM_UNIT
   qualifier WRAP
   qualifier PRINTALL
   qualifier LOG
   qualifier TRUNCATE
   qualifier TAB
   qualifier SIXELS
   qualifier BITMAPPED

define syntax SET_PROCESS
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=PROCESS, prompt="Process"
      value (type=$process)
   qualifier IDENTIFICATION
      value (required)
   qualifier PRIORITY
      value (required)
   qualifier RESOURCE_WAIT
   qualifier SWAPPING
   qualifier PRIVILEGES, nonnegatable
      value (required,list,type=PRIVILEGES)
   qualifier SUSPEND
      value (type=SUSPEND_TYPE)
   qualifier RESUME
   qualifier NAME
      value (required)
   qualifier LOG
   qualifier DUMP
   qualifier CPU
      value (required,type=BOUND_CPU)
   qualifier AUTO_UNSHELVE

define type SUSPEND_TYPE
   keyword SUPERVISOR
   keyword KERNEL

define type BOUND_CPU
   keyword ATTACHED, negatable
define type PRIVILEGES
   keyword ACNT, negatable
   keyword ALLSPOOL, negatable
   keyword ALTPRI, negatable
   keyword AUDIT, negatable
   keyword BUGCHK, negatable
   keyword BYPASS, negatable
   keyword CMEXEC, negatable
   keyword CMKRNL, negatable
   keyword DETACH, negatable
   keyword DIAGNOSE, negatable
   keyword DOWNGRADE, negatable
   keyword EXQUOTA, negatable
   keyword GROUP, negatable
   keyword GRPNAM, negatable
   keyword GRPPRV, negatable
   keyword IMPORT, negatable
   keyword LOG_IO, negatable
   keyword MOUNT, negatable
   keyword NETMBX, negatable
   keyword OPER, negatable
   keyword PFNMAP, negatable
   keyword PHY_IO, negatable
   keyword PRMCEB, negatable
   keyword PRMGBL, negatable
   keyword PRMJNL, negatable
   keyword PRMMBX, negatable
   keyword PSWAPM, negatable
   keyword SAME, negatable
   keyword READALL, negatable
   keyword SECURITY, negatable
   keyword SETPRV, negatable
   keyword SHARE, negatable
   keyword SHMEM, negatable
   keyword SYSLCK, negatable
   keyword SYSGBL, negatable
   keyword SYSNAM, negatable
   keyword SYSPRV, negatable
   keyword TMPJNL, negatable
   keyword TMPMBX, negatable
   keyword UPGRADE, negatable
   keyword VOLPRO, negatable
   keyword WORLD, negatable

define syntax SET_PROTECTION
   parameter P1, label=OPTION
      value (required,type=SET_OPTIONS)
   parameter P2, label=FILE, prompt="File"
      value (required,list,impcat,type=$infile)
   qualifier DEFAULT, syntax=SET_DEF_PROT, nonnegatable
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
      placement=local
   qualifier DEVICE
   qualifier OWNER_UIC
      value (type=$uic)
   qualifier CONFIRM
   qualifier LOG

define type PROTECTION
   keyword SYSTEM
      value
   keyword GROUP
      value
   keyword OWNER
      value
   keyword WORLD
      value

define syntax SET_DEF_PROT
   cliroutine SETPROT
   prefix CLI$K_STPR_
   parameter P1, label=OPTION
      value (required)
   qualifier DEFAULT

define syntax SET_TERMINAL
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (type=$device)
   qualifier APPLICATION_KEYPAD
   qualifier BROADCAST
   qualifier CRFILL
      value
   qualifier DISMISS_PARITY
   qualifier ECHO
   qualifier EIGHT_BIT
   qualifier ESCAPE
   qualifier HARDCOPY
   qualifier HOLD_SCREEN
   qualifier HOSTSYNC
   qualifier INTERACTIVE
   qualifier LA36, nonnegatable
   qualifier LFFILL
      value
   qualifier FORM
   qualifier FRAME, nonnegatable
      value
   qualifier LOWERCASE
   qualifier NUMERIC_KEYPAD
   qualifier PAGE
      value
   qualifier PASSALL
   qualifier LA120, nonnegatable
   qualifier SCOPE
   qualifier SCRIBE
   qualifier SPEED
      value (required,list)
   qualifier TAB
   qualifier TTSYNC
   qualifier TYPEAHEAD
   qualifier UNKNOWN, nonnegatable
   qualifier UPPERCASE
   qualifier VT05, nonnegatable
   qualifier VT52, nonnegatable
   qualifier VT55, nonnegatable
   qualifier WIDTH
      value
   qualifier WRAP
   qualifier PARITY
      value
   qualifier READSYNC
   qualifier PERMANENT, nonnegatable
   qualifier VT100, nonnegatable
   qualifier FT1, nonnegatable
   qualifier FT2, nonnegatable
   qualifier FT3, nonnegatable
   qualifier FT4, nonnegatable
   qualifier FT5, nonnegatable
   qualifier FT6, nonnegatable
   qualifier FT7, nonnegatable
   qualifier FT8, nonnegatable
   qualifier FULLDUP
   qualifier HALFDUP
   qualifier LOCAL_ECHO
   qualifier AUTOBAUD
   qualifier HANGUP
   qualifier BRDCSTMBX
   qualifier DMA
   qualifier ALTYPEAHD, nonnegatable
   qualifier ANSI_CRT
   qualifier REGIS
   qualifier BLOCK_MODE
   qualifier ADVANCED_VIDEO
   qualifier XON, nonnegatable
   qualifier DEVICE_TYPE, nonnegatable
      value (required)
   qualifier MODEM
   qualifier INQUIRE, nonnegatable
      value (type=INQUIRE_TYPES)
   qualifier DEC_CRT
      value (list)
   qualifier EDIT
   qualifier SET_SPEED
   qualifier LINE_EDITING
   qualifier DISCONNECT
   qualifier FALLBACK
   qualifier DIALUP
   qualifier INSERT_EDITING
   qualifier PRINTER_PORT
   qualifier SECURE_SERVER
   qualifier SIXEL
   qualifier SOFT_CHARACTERS
   qualifier OVERSTRIKE
   qualifier LOG
   qualifier PASTHRU
   qualifier SYSPASSWORD
   qualifier PROTOCOL, nonnegatable
      value (required,type=PROTOCOL_TYPES)
   qualifier X29, syntax=SET_TERM_X29, nonnegatable
   qualifier SWITCH, nonnegatable
      value (required,type=SWITCH_TYPES)
   qualifier MANUAL
   qualifier NETWORK
   qualifier POSIX
   qualifier COMMSYNC
   disallow (PROTOCOL and NETWORK)
   disallow (COMMSYNC and MODEM)

define type INQUIRE_TYPES
   keyword OLD, label=INQUIRE_OLD

define type PROTOCOL_TYPES
   keyword NONE
   keyword DDCMP

define syntax SET_TERM_X29
   image PSISETX29
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (type=$device)
   qualifier HOLD_TIMER, label=PSISETX29_HOLD_TIMER
      value (required,type=$number)
   qualifier INTERRUPT, label=PSISETX29_INTERRUPT
      value (required,list,type=PSISETX29_INT_BRK)
   qualifier BREAK, label=PSISETX29_BREAK
      value (required,list,type=PSISETX29_INT_BRK)
   qualifier PARAMETERS, label=PSISETX29_PARAMETERS
      value (required,list,type=X29_PARAM_TYPE)
   qualifier NETWORK_SPECIFIC, label=PSISETX29_NETWORK_SPECIFIC
      value (required,list)
   qualifier PERMANENT, label=PSISETX29_PERMANENT, nonnegatable
   qualifier TEMPLATE, label=PSISETX29_TEMPLATE, nonnegatable
      value (required,list,type=X29_TEMPLATE_TYPE)
   qualifier LOG, label=PSISETX29_LOG

define type PSISETX29_INT_BRK
   keyword ACTION, label=PSISETX29_ACTION, negatable
      value (required,list,type=PSISETX29_ACTION)
   keyword STRING, label=PSISETX29_STRING, negatable
      value (required)

define type PSISETX29_ACTION
   keyword PURGE, label=PSISETX29_PURGE, negatable
   keyword RESET, label=PSISETX29_RESET, negatable
   keyword CLEAR, label=PSISETX29_CLEAR, negatable

define type X29_PARAM_TYPE
   keyword BREAK, label=X29_BREAK, negatable
      value (default="1",type=$number)
   keyword 7, label=X29_BREAK_N
      value (required,type=$number)
   keyword CRFILL, label=X29_CRFILL, negatable
      value (default="1",type=$number)
   keyword 9, label=X29_CRFILL_N
      value (required,type=$number)
   keyword DELETE, label=X29_DELETE, negatable
      value (default="1",type=$number)
   keyword 16, label=X29_DELETE_N
      value (required,type=$number)
   keyword DISCARD_OUTPUT, label=X29_DISCARD_OUTPUT, negatable
      value (default="1",type=$number)
   keyword 8, label=X29_DISCARD_OUTPUT_N
      value (required,type=$number)
   keyword ECHO, label=X29_ECHO, negatable
      value (default="1",type=$number)
   keyword 2, label=X29_ECHO_N
      value (required,type=$number)
   keyword EDIT, label=X29_EDIT, negatable
      value (default="1",type=$number)
   keyword 15, label=X29_EDIT_N
      value (required,type=$number)
   keyword ESCAPE_CHARACTER, label=X29_ESCAPE, negatable
      value (default="1",type=$number)
   keyword 1, label=X29_ESCAPE_N
      value (required,type=$number)
   keyword FORWARDING_CHARACTERS, label=X29_FORWARDING, negatable
      value (default="1",type=$number)
   keyword 3, label=X29_FORWARDING_N
      value (required,type=$number)
   keyword HOSTSYNC, label=X29_HOSTSYNC, negatable
      value (default="1",type=$number)
   keyword 5, label=X29_HOSTSYNC_N
      value (required,type=$number)
   keyword LFFILL, label=X29_LFFILL, negatable
      value (default="1",type=$number)
   keyword 14, label=X29_LFFILL_N
      value (required,type=$number)
   keyword LINE_DELETE, label=X29_LINE_DELETE, negatable
      value (default="1",type=$number)
   keyword 17, label=X29_LINE_DELETE_N
      value (required,type=$number)
   keyword MESSAGES, label=X29_MESSAGES, negatable
      value (default="1",type=$number)
   keyword 6, label=X29_MESSAGES_N
      value (required,type=$number)
   keyword NEW_LINE, label=X29_NEW_LINE, negatable
      value (default="1",type=$number)
   keyword 13, label=X29_NEW_LINE_N
      value (required,type=$number)
   keyword REDISPLAY_LINE, label=X29_REDISPLAY_LINE, negatable
      value (default="1",type=$number)
   keyword 18, label=X29_REDISPLAY_LINE_N
      value (required,type=$number)
   keyword SPEED, label=X29_SPEED, negatable
      value (default="1",type=$number)
   keyword 11, label=X29_SPEED_N
      value (required,type=$number)
   keyword TIMEOUT, label=X29_TIMEOUT, negatable
      value (default="1",type=$number)
   keyword 4, label=X29_TIMEOUT_N
      value (required,type=$number)
   keyword TTSYNC, label=X29_TTSYNC, negatable
      value (default="1",type=$number)
   keyword 12, label=X29_TTSYNC_N
      value (required,type=$number)
   keyword WRAP, label=X29_WRAP, negatable
      value (default="1",type=$number)
   keyword 10, label=X29_WRAP_N
      value (required,type=$number)
   keyword DISPLAY_EDIT, label=X29_DISPLAY_EDIT, negatable
      value (default="1",type=$number)
   keyword 19, label=X29_DISPLAY_EDIT_N
      value (type=$number)
   keyword RESTRICT_ECHO, label=X29_RESTRICT_ECHO, negatable
      value (default="1",type=$number)
   keyword 20, label=X29_RESTRICT_ECHO_N
      value (type=$number)
   keyword PARITY, label=X29_PARITY, negatable
      value (default="1",type=$number)
   keyword 21, label=X29_PARITY_N
      value (type=$number)
   keyword PAGE_WAIT, label=X29_PAGE_WAIT, negatable
      value (default="1",type=$number)
   keyword 22, label=X29_PAGE_WAIT_N
      value (type=$number)

define type X29_TEMPLATE_TYPE
   keyword LOCAL_ECHO, label=PSISETX29_LOCAL
      value (required,list,type=$acl)
   keyword HOST_ECHO, label=PSISETX29_HOST
      value (required,list,type=$acl)
   keyword HANGUP, label=PSISETX29_HANGUP
      value (required,list,type=$acl)

define type SWITCH_TYPES
   keyword DECNET
   keyword LOCAL

define syntax SET_UIC
   cliroutine SETUIC
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="UIC"
      value (required,type=$uic)
   noqualifiers

define type VERIFY_KEYS
   keyword PROCEDURE, negatable
   keyword IMAGE, negatable

define syntax SET_VERIFY
   cliroutine SETVERIFY
   parameter P1, label=OPTION
      value (required,type=SET_OPTIONS)
   disallow (not OPTION.VERIFY and (OPTION.VERIFY.PROCEDURE or 
      OPTION.VERIFY.IMAGE))
   disallow (not OPTION.VERIFY and (neg OPTION.VERIFY.PROCEDURE or neg 
      OPTION.VERIFY.IMAGE))

define syntax SET_VOLUME
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=VOLUME, prompt="Volume"
      value (required,list,type=$infile)
   qualifier ACCESSED
      value
   qualifier DATA_CHECK
      value (list)
   qualifier ERASE_ON_DELETE
   qualifier EXTENSION
      value
   qualifier FILE_PROTECTION
      value (required,list,type=PROTECTION)
   qualifier HIGHWATER_MARKING
   qualifier LABEL
      value (required)
   qualifier LOG
   qualifier MOUNT_VERIFICATION
   qualifier OWNER_UIC
      value (type=$uic)
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier REBUILD
      value (list)
   qualifier RETENTION
      value (required,list)
   qualifier UNLOAD
   qualifier USER_NAME
      value
   qualifier WINDOWS
      value
   qualifier SUBSYSTEM
   qualifier WRITETHROUGH

define syntax SET_WORKING_SET
   parameter P1, label=OPTION
      value (required)
   qualifier LIMIT
      value (required)
   qualifier QUOTA
      value (required)
   qualifier EXTENT
      value (required)
   qualifier ADJUST
   qualifier LOG

define syntax SET_RMS_DEFAULT
   parameter P1, label=OPTION
      value (required)
   qualifier BLOCK_COUNT
      value (required)
   qualifier BUFFER_COUNT
      value (required)
   qualifier DISK
   qualifier MAGTAPE
   qualifier UNIT_RECORD
   qualifier HASH
   qualifier INDEXED
   qualifier RELATIVE
   qualifier SEQUENTIAL
   qualifier SYSTEM
   qualifier SPACE_HOLDER
   qualifier PROLOGUE
      value (required)
   qualifier EXTEND_QUANTITY
      value (required)
   qualifier NETWORK_BLOCK_COUNT
      value (required)

define type CONTROL_KEYS
   keyword T
   keyword Y

define syntax SET_CONTROL
   cliroutine SETCTLY
   parameter P1, label=OPTION
      value (required)
   noqualifiers

define syntax SET_TIME
   parameter P1, label=OPTION
      value (required,type=SET_OPTIONS)
   qualifier CLUSTER

define syntax SET_HOST
   image RTPAD
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=NODE, prompt="Node"
      value (required)
   qualifier DUP, syntax=SET_HOST_DUP, nonnegatable
   qualifier HSC, syntax=SET_HOST_HSC, nonnegatable
   qualifier LOG
      value (default="SETHOST.LOG",type=$outfile)
   qualifier RESTORE
   qualifier BUFFER_SIZE, nonnegatable
      value (required,type=$number)

define syntax SET_HOST_DUP
   image HSCPAD
   qualifier DUP, nonnegatable, default
   qualifier HSC
   qualifier LOG
      value (default="HSCPAD.LOG",type=$outfile)
   qualifier SERVER, nonnegatable
      value (required,type=$quoted_string)
   qualifier STANDALONE, nonnegatable
   qualifier SYSTEMID, nonnegatable
   qualifier DEVICE, nonnegatable
   qualifier TASK, nonnegatable
      value (required,type=$quoted_string)
   qualifier LOAD_FILE
      value (required,type=$infile)
   disallow (DUP and HSC)
   disallow (SYSTEMID and DEVICE)
   disallow (TASK and LOAD_FILE)

define syntax SET_HOST_HSC
   image HSCPAD
   qualifier DUP
   qualifier HSC, nonnegatable, default
   qualifier LOG
      value (default="HSCPAD.LOG",type=$outfile)
   qualifier STANDALONE, nonnegatable
   qualifier SYSTEMID, nonnegatable
   qualifier DEVICE, nonnegatable
   disallow ((DUP or STANDALONE) and HSC)
   disallow (SYSTEMID and DEVICE)

define syntax SET_COMMAND
   image CDU
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=CLD_SPEC, prompt="CLD File(s)"
      value (list,type=$infile)
   qualifier ALPHA, nonnegatable
   qualifier DELETE
      value (required,list)
   qualifier OBJECT
      value (type=$outfile)
   qualifier REPLACE, default
   qualifier SYMBOLS
      value (required,type=$outfile)
   qualifier CLI, nonnegatable, default
      value (required,type=CLI_NAMES)
   qualifier LISTING
      value (type=$outfile)
   qualifier LOG
   qualifier OUTPUT, default
      value (type=$outfile)
   qualifier TABLES, default
      value (type=$infile)
   qualifier VAX, nonnegatable
   disallow (VAX and ALPHA)
   disallow any2 (DELETE, OBJECT, REPLACE, SYMBOLS)
   disallow (LISTING and (DELETE or SYMBOLS))

define type CLI_NAMES
   keyword DCL, label=CLI_DCL, default
   keyword MCR, label=CLI_MCR

define syntax SET_DAY
   parameter P1, label=OPTION
      value (required)
   qualifier PRIMARY
   qualifier SECONDARY
   qualifier DEFAULT
   qualifier LOG
   disallow (PRIMARY and SECONDARY)

define syntax SET_PROMPT
   cliroutine SETPROMPT
   parameter P1, label=OPTION
      value
   qualifier CARRIAGE_CONTROL

define syntax SET_PREFIX
   cliroutine SETPREFIX
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="Format string"

define syntax SET_KEY
   cliroutine SETKEY
   prefix CLI$K_STKY_
   qualifier STATE
      value (required)
   qualifier LOG

define syntax SET_OUTPUT_RATE
   cliroutine SETFLUSH
   parameter P1, label=OPTION
      value (required,type=SET_OPTIONS)

define syntax SET_SYMBOL
   cliroutine SETSYMBOL
   parameter P1, label=OPTION
      value (required)
   qualifier SCOPE
      value (required,list,type=SCOPE_TYPES)
   qualifier GENERAL, nonnegatable
   qualifier VERB, nonnegatable
   qualifier ALL, nonnegatable, default
   disallow ((GENERAL and VERB) or (GENERAL and ALL) or (VERB and 
      ALL))

define type SCOPE_TYPES
   keyword LOCAL, negatable
   keyword GLOBAL, negatable

define syntax SET_WATCH
   image SETWATCH
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=WATCH_OPTION, prompt="What"
      value (required,type=WATCH_OPTIONS)
   qualifier CLASS
      value (required,list,type=WATCH_CLASSES)
   disallow not CLASS

define type WATCH_OPTIONS
   keyword FILE

define type WATCH_CLASSES
   keyword ALL, negatable
   keyword ATTRIBUTES, negatable
   keyword CONTROL_FUNCTION, negatable
   keyword DIRECTORY_OPERATIONS, negatable
   keyword DUMP, negatable
   keyword ATTACHED, negatable
   keyword MAJOR_FUNCTION, negatable
   keyword NONE
   keyword QUOTA_OPERATIONS, negatable
   keyword PROTECTION, negatable

define syntax SET_SECURITY
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Object"
   qualifier ACL
      value (list,type=$acl)
   qualifier AFTER
      value (required,type=$acl)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY")
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CONFIRM
   qualifier COPY_ATTRIBUTE
      value (required,list,type=SECUR_COPY_ATTR)
   qualifier CREATED
   qualifier DEFAULT
   qualifier DELETE
      value (type=SET_SECUR_DELETE)
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier LIKE
      value (required,list,type=SET_SECUR_LIKE)
   qualifier LOG
   qualifier MODIFIED
   qualifier OBJECT_TYPE
      value (required)
   qualifier CLASS
      value (required)
   qualifier OWNER
      value (type=$uic)
   qualifier PROFILE
      value (required,type=SECUR_PROFILE)
   qualifier PROTECTION
      value (required,list,type=PROTECTION)
   qualifier REPLACE
      value (required,list,type=$acl)
   qualifier SINCE
      value (default="TODAY")
   qualifier SECRECY, label=SECURITY
      value (required,type=$acl)
   qualifier SQ1
      value (required)
   qualifier SQ2
      value (required)
   qualifier SQ3
      value (required)
   qualifier SQ4
      value (required)
   qualifier INTEGRITY
      value (required,type=$acl)
   disallow (CLASS and OBJECT_TYPE)
   disallow (LIKE and DEFAULT)
   disallow ((LIKE or DEFAULT) and (OWNER or PROTECTION or ACL))
   disallow (COPY_ATTRIBUTE and not (DEFAULT or LIKE))
   disallow any2 (DELETE, AFTER, REPLACE)
   disallow ((REPLACE or AFTER or DELETE) and not ACL)
   disallow any2 (BACKUP, CREATED, EXPIRED, MODIFIED)
   disallow ((BACKUP or CREATED or EXPIRED or MODIFIED) and not (
      BEFORE or SINCE))

define type SECUR_COPY_ATTR
   keyword ALL, default
   keyword ACL
   keyword OWNER
   keyword PROTECTION

define type SET_SECUR_DELETE
   keyword ALL

define type SET_SECUR_LIKE
   keyword OBJECT_NAME
      value (required)
   keyword OBJECT_TYPE
      value (required)
   keyword NAME
      value (required)
   keyword CLASS
      value (required)
   keyword PROFILE
      value (type=SECUR_PROFILE)

define verb SHOW
   synonym SH
   image SHOW
   parameter P1, label=OPTION, prompt="What"
      value (required,type=SHOW_OPTIONS)

define type SHOW_OPTIONS
   keyword ACL, syntax=SHOW_ACL
   keyword BROADCAST, syntax=SHOW_BROAD
   keyword DAYTIME, syntax=SHOW_DAYTIME
   keyword TIME, syntax=SHOW_DAYTIME
   keyword DEFAULT, syntax=SHOW_DEFAULT
   keyword LOGICAL, syntax=SHOW_LOGICAL
   keyword PROTECTION, syntax=SHOW_PROTECTION
   keyword SYMBOL, syntax=SHOW_SYMBOL
   keyword TRANSLATION, syntax=SHOW_TRANSLATION
   keyword WORKING_SET, syntax=SHOW_BROAD
   keyword DEVICES, syntax=SHOW_DEVICE
   keyword STATUS, syntax=SHOW_STATUS
   keyword PROCESS, syntax=SHOW_PROCESS
   keyword SYSTEM, syntax=SHOW_SYSTEM
   keyword TERMINAL, syntax=SHOW_TERMINAL
   keyword PRINTER, syntax=SHOW_PRINTER
   keyword NETWORK, syntax=SHOW_BROAD
   keyword RMS_DEFAULT, syntax=SHOW_BROAD
   keyword MAGTAPE, syntax=SHOW_MAGTAPE
   keyword QUOTA, syntax=SHOW_QUOTA
   keyword MEMORY, syntax=SHOW_MEMORY
   keyword USERS, syntax=SHOW_USER
   keyword ERROR, syntax=SHOW_ERROR
   keyword KEY, syntax=SHOW_KEY
      cliflags(mcrignore)
   keyword SECURITY, syntax=SHOW_SECURITY

define syntax SHOW_ACL
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Object name"
      value (required)
   qualifier OBJECT_TYPE
      value (required,type=ACL_OBJECTS)
   qualifier CLASS
      value (required)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY")
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CREATED
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier MODIFIED
   qualifier SINCE
      value (default="TODAY")
   disallow (CLASS and OBJECT_TYPE)
   disallow ((BACKUP or CREATED or EXPIRED or MODIFIED) and not (
      BEFORE or SINCE))

define syntax SHOW_BROAD
   parameter P1, label=OPTION
      value (required)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)

define syntax SHOW_DAYTIME
   cliroutine SHOWTIME
   parameter P1, label=OPTION
      value (required)
   noqualifiers

define syntax SHOW_DEFAULT
   cliroutine SHOWDEF
   parameter P1, label=OPTION
      value (required)
   noqualifiers

define syntax SHOW_LOGICAL
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=LOGNAME, prompt="Logical name"
      value (list,type=$inlog)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier SYSTEM
   qualifier GROUP
   qualifier PROCESS
   qualifier JOB
   qualifier ALL
   qualifier TABLE
      value (required,list)
   qualifier DESCENDANTS
   qualifier STRUCTURE
   qualifier ACCESS_MODE
      value (required,type=ACMODE)
   qualifier FULL
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)
   disallow (STRUCTURE and (SYSTEM or GROUP or JOB or PROCESS or 
      TABLE or DESCENDANTS))

define type ACMODE
   keyword USER_MODE
   keyword SUPERVISOR_MODE
   keyword EXECUTIVE_MODE
   keyword KERNEL_MODE

define syntax SHOW_PROTECTION
   cliroutine SHOWPROT
   parameter P1, label=OPTION
      value (required)
   qualifier DEFAULT

define syntax SHOW_SYMBOL
   cliroutine SHOWSYMBL, cliflags(nostatus)
   prefix CLI$K_SHSY_
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="Symbol"
      value (required,type=$insym)
   qualifier GLOBAL, nonnegatable
      placement=positional
   qualifier LOCAL, nonnegatable
      placement=positional
   qualifier ALL, syntax=SHOW_ALL_SYMBOLS, nonnegatable
      placement=positional
   qualifier LOG

define syntax SHOW_ALL_SYMBOLS
   parameter P1, label=OPTION
      value (required)

define syntax SHOW_TRANSLATION
   cliroutine SHOWTRAN
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="Log_name"
      value (required,type=$inlog)
   qualifier TABLE
      value (required)

define syntax SHOW_DEVICE
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (type=$device)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier ALLOCATED
   qualifier BRIEF
   qualifier FULL
   qualifier MOUNTED
   qualifier FILES
   qualifier SYSTEM
   qualifier WINDOWS
   qualifier SERVED, syntax=SHOW_SERVED, nonnegatable
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   qualifier REBUILD_STATUS, nonnegatable
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)
   disallow (SERVED and (ALLOCATED or BRIEF or FULL or MOUNTED or 
      FILES or SYSTEM or WINDOWS or REBUILD_STATUS))
   disallow (REBUILD_STATUS and (ALLOCATED or BRIEF or FULL or 
      MOUNTED or FILES or SERVED or SYSTEM or WINDOWS))

define syntax SHOW_SERVED
   parameter P1, label=OPTION
      value (required)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier ALL
   qualifier COUNT
   qualifier HOST
   qualifier RESOURCE
   qualifier SERVED, nonnegatable, default
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)

define syntax SHOW_STATUS
   cliroutine SHOWSTAT, cliflags(nostatus)
   parameter P1, label=OPTION
      value (required)
   noqualifiers

define syntax SHOW_PROCESS
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=PROCESS, prompt="Process"
      value (type=$process)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier QUOTAS, nonnegatable
   qualifier ACCOUNTING, nonnegatable
   qualifier PRIVILEGES, nonnegatable
   qualifier RIGHTS
   qualifier MEMORY, nonnegatable
   qualifier SUBPROCESSES, nonnegatable
   qualifier IDENTIFICATION, nonnegatable
      value (required)
   qualifier CONTINUOUS, nonnegatable
   qualifier INTERVAL, nonnegatable
      value (required,type=$number)
   qualifier ALL, nonnegatable
   qualifier CHARGE_CODE, nonnegatable
   qualifier SHELVING, nonnegatable
   qualifier DUMP, nonnegatable
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow ((CONTINUOUS or OUTPUT) and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)
   disallow (CONTINUOUS and OUTPUT)

define syntax SHOW_SYSTEM
   parameter P1, label=OPTION
      value (required)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier PROCESS
      value
   qualifier CLUSTER
   qualifier NODE, nonnegatable
      value (list)
   qualifier BATCH
   qualifier SUBPROCESS
   qualifier NETWORK
   qualifier INTERACTIVE
   qualifier FULL, nonnegatable
   qualifier GRAND_TOTAL
   qualifier HEADING
   qualifier IDENTIFICATION, nonnegatable
      value (required)
   qualifier OWNER_UIC, nonnegatable
      value (required,type=$uic)
   qualifier STATE, nonnegatable
      value (required,list)
   qualifier TOTAL
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)
   disallow (CLUSTER and NODE)
   disallow (neg HEADING and neg PROCESS)
   disallow ((OWNER_UIC or PROCESS) and (GRAND_TOTAL or TOTAL or 
      IDENTIFICATION))
   disallow (neg PROCESS and (IDENTIFICATION or OWNER_UIC or 
      STATE))
   disallow ((BATCH or SUBPROCESS or NETWORK or INTERACTIVE) and (neg 
      BATCH or neg SUBPROCESS or neg NETWORK or neg INTERACTIVE))
   disallow (IDENTIFICATION and ((BATCH or SUBPROCESS or NETWORK or 
      INTERACTIVE) or (neg BATCH or neg SUBPROCESS or neg NETWORK or neg 
      INTERACTIVE)))

define syntax SHOW_TERMINAL
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (type=$device)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier PERMANENT, nonnegatable
   qualifier BRIEF, nonnegatable
   qualifier FULL, nonnegatable
   disallow (FULL and BRIEF)

define syntax SHOW_PRINTER
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)

define syntax SHOW_MAGTAPE
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=DEVICE, prompt="Device"
      value (required,type=$device)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)

define syntax SHOW_QUOTA
   cliroutine SHOWQUOTA
   prefix CLI$K_SHQO_
   parameter P1, label=OPTION
      value (required)
   qualifier DISK, default
      value (type=$device)
   qualifier USER
      value (required,type=$uic)

define syntax SHOW_MEMORY
   parameter P1, label=OPTION
      value (required)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier PHYSICAL_MEMORY, nonnegatable
   qualifier SLOTS, nonnegatable
   qualifier POOL, nonnegatable
   qualifier FILES, nonnegatable
   qualifier CACHE, nonnegatable
   qualifier FULL, nonnegatable
   qualifier ALL, nonnegatable
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)

define syntax SHOW_USER
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=USERNAME, prompt="Username"
      value
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier CLUSTER, default
   qualifier FULL, nonnegatable
   qualifier NODE, nonnegatable
      value (list)
   qualifier BATCH
   qualifier SUBPROCESS
   qualifier NETWORK
   qualifier INTERACTIVE
   qualifier HEADING
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)
   disallow (CLUSTER and NODE)
   disallow ((BATCH or SUBPROCESS or NETWORK or INTERACTIVE) and (neg 
      BATCH or neg SUBPROCESS or neg NETWORK or neg INTERACTIVE))

define syntax SHOW_ERROR
   parameter P1, label=OPTION
      value (required)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier BRIEF, nonnegatable
   qualifier FULL, nonnegatable
   qualifier EXACT
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE and (SEARCH or WRAP or EXACT or HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)

define syntax SHOW_KEY
   cliroutine SHOWKEY
   prefix CLI$K_SHKY_
   parameter P1, label=OPTION
      value (required)
   parameter P2, prompt="Key name"
      value (required)
   qualifier ALL, syntax=SHOW_ALL_KEYS
   qualifier STATE
      value (required,list)
   qualifier BRIEF
   qualifier DIRECTORY, syntax=SHOW_ALL_STATES
   qualifier FULL
   qualifier LOG
   disallow (DIRECTORY and (BRIEF or STATE or ALL or FULL))

define syntax SHOW_ALL_KEYS
   parameter P1, label=OPTION
      value (required)

define syntax SHOW_ALL_STATES
   parameter P1, label=OPTION
      value (required)

define syntax SHOW_SECURITY
   image SETSHOSECUR
   parameter P1, label=OPTION
      value (required)
   parameter P2, label=INPUT, prompt="Object name"
      value (required)
   qualifier OBJECT_TYPE
      value (required)
   qualifier CLASS
      value (required)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY")
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CREATED
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier MODIFIED
   qualifier SINCE
      value (default="TODAY")
   disallow (CLASS and OBJECT_TYPE)
   disallow ((BACKUP or CREATED or EXPIRED or MODIFIED) and not (
      BEFORE or SINCE))

define verb SPAWN
   cliroutine SPAWN
   prefix CLI$K_SPAW_
   parameter P1
      value (type=$rest_of_line)
   qualifier PROCESS
      value (required)
   qualifier WAIT, default
   qualifier LOG, default
   qualifier INPUT
      value (required,type=$infile)
   qualifier OUTPUT
      value (required,type=$outfile)
   qualifier SYMBOLS, default
      cliflags(mcrignore)
   qualifier LOGICAL_NAMES, default
   qualifier NOTIFY
   qualifier CARRIAGE_CONTROL
      cliflags(mcrignore)
   qualifier PROMPT
      value
      cliflags(mcrignore)
   qualifier KEYPAD, default
      cliflags(mcrignore)
   qualifier CLI
      value (required,type=$file)
   qualifier TABLE
      value (required,type=$file)
   qualifier TRUSTED
   qualifier PRIVILEGES
      value (required,type=SPAWN_PRIVS)

define type SPAWN_PRIVS
   keyword CURRENT
   keyword AUTHORIZED

define verb STOP
   cliroutine STOP, cliflags(nostatus)
   parameter P1, prompt="Process"
      value (type=$process)
   qualifier IDENTIFICATION, nonnegatable
      value (required)

define verb SUBROUTINE
   cliroutine SUBROUTINE
   noparameters

define verb THEN
   cliroutine THEN, cliflags(nostatus)
   parameter P1
      value (type=$rest_of_line)

define verb TYPE
   image TYPE
   parameter P1, label=INPUT, prompt="File"
      value (required,list,impcat,type=$infile)
   qualifier BACKUP
   qualifier BEFORE
      value (default="TODAY",type=$datetime)
   qualifier BY_OWNER
      value (type=$uic)
   qualifier CONFIRM
   qualifier CONTINUOUS
   qualifier CREATED
   qualifier EXACT
   qualifier EXCLUDE
      value (required,list)
   qualifier EXPIRED
   qualifier HEADER
   qualifier HIGHLIGHT, nonnegatable
      value (list,type=HIGHLIGHT_OPTIONS)
   qualifier INTERVAL, nonnegatable
      value (required,type=$number)
   qualifier MODIFIED
   qualifier ON
      value (default="TODAY",type=$datetime)
   qualifier OUTPUT, default
      value (default="SYS$OUTPUT",type=$file)
   qualifier PAGE
      value (list,type=PAGE_OPTIONS)
   qualifier SEARCH, nonnegatable
      value (required)
   qualifier SINCE
      value (default="TODAY",type=$datetime)
   qualifier TAIL
      value (type=$number)
   qualifier WRAP
   disallow (OUTPUT and PAGE)
   disallow (not PAGE.PAGE_SAVE and (EXACT or SEARCH or WRAP or 
      HIGHLIGHT))
   disallow any2 (HIGHLIGHT.HIGHLIGHT_BLUE, HIGHLIGHT.HIGHLIGHT_CYAN, 
      HIGHLIGHT.HIGHLIGHT_GREEN, HIGHLIGHT.HIGHLIGHT_MAGENTA, 
      HIGHLIGHT.HIGHLIGHT_RED, HIGHLIGHT.HIGHLIGHT_YELLOW)

define type HIGHLIGHT_OPTIONS
   keyword REVERSE, label=HIGHLIGHT_REVERSE
   keyword BOLD, label=HIGHLIGHT_BOLD
   keyword BLINK, label=HIGHLIGHT_BLINK
   keyword UNDERLINE, label=HIGHLIGHT_UNDERLINE
   keyword BLUE, label=HIGHLIGHT_BLUE
   keyword CYAN, label=HIGHLIGHT_CYAN
   keyword GREEN, label=HIGHLIGHT_GREEN
   keyword MAGENTA, label=HIGHLIGHT_MAGENTA
   keyword RED, label=HIGHLIGHT_RED
   keyword YELLOW, label=HIGHLIGHT_YELLOW

define type PAGE_OPTIONS
   keyword CLEAR_SCREEN, label=PAGE_CLEAR_SCREEN
   keyword SCROLL, label=PAGE_SCROLL
   keyword SAVE, label=PAGE_SAVE, negatable
      value (type=$number)

define verb WAIT
   cliroutine WAIT, cliflags(nostatus, immediate)

define verb WRITE
   cliroutine WRITE
   prefix CLI$K_WRIT_
   parameter P1, prompt="Log name"
      value (required,type=$inlog)
   parameter P2, prompt="Expression"
      value (required,list,type=$expression)
   qualifier END_OF_FILE
      value (required)
   qualifier ERROR
      value (required)
   qualifier UPDATE
   qualifier SYMBOLS, syntax=WRITE_SYMBOL_OUT, nonnegatable

define syntax WRITE_SYMBOL_OUT
   parameter P1, prompt="Log name"
      value (required,type=$inlog)
   parameter P2, prompt="Symbol"
      value (required,list,type=$quoted_string)
$ EOD
$	purge sys$scratch:dcltbl_'f$getjpi("","PID").exe
$	delete sys$scratch:dcltbl_'f$getjpi("","PID").obj;
$	return
